/*jshint camelcase:false, plusplus:false, proto:true, evil:true, esnext:true, moz:true, unused: vars */
/*global gBrowser, Cc, Ci, XPCOMUtils */

var aSession;

var AdBlockPlus;

var prevDoc;

var ads_app_is_enabled = true;
var beautifier_is_enabled = false;
var confineAll = false; // also transform html pages and same-domain js
var useAdBlock = false;
var policyEnabled = false;
var logPolicyEnabled = false;


var tlds = Cc["@mozilla.org/network/effective-tld-service;1"]
.getService(Ci.nsIEffectiveTLDService);


var scriptCache = {};
var docCache = {};

string_splice = function(orig, idx, rem, s) {
	return (orig.slice(0,idx) + s + orig.slice(idx + Math.abs(rem)));
};

if (winNum() === 1){ // this makes sure that httprequest observer is registered once
	window.addEventListener("load", function () {
		myExtension.init();
	}, false);

	window.addEventListener("unload", function () {
		myExtension.uninit();
	}, false);
}

getDomain = function (sURL) {
	var first = sURL.indexOf("://");
	if (first>=0) {
		var second = sURL.indexOf("/",first+3);
		second = (second>=0)?second:sURL.length;
		return sURL.substring(first+3,second);
	}
	dump("Error: getting domain of "+ sURL);
	return undefined;
};


function currentURL(){
	var currentWindow = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator).getMostRecentWindow("navigator:browser");
	var currBrowser = currentWindow.getBrowser();
	var url = currBrowser.currentURI.spec;
	return url;
}


function winNum(){
	var num = 0;
	var enumerator = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator).getEnumerator("navigator:browser");
	while (enumerator.hasMoreElements()) {
		enumerator.getNext();
		num++;
	}
	return num;
}

var myExtension = {
	oldURL: null,

	init: function () {
		aSession.httpRequestObserver.register();
		gBrowser.addProgressListener(this);
	},
	uninit: function () {
		gBrowser.removeProgressListener(this);
	},
	processNewURL: function (aURI, request) {
		if (aURI.spec.indexOf("http") !== -1) {
			if (prevDoc !== gBrowser.contentDocument) {
				prevDoc = gBrowser.contentDocument;
				aSession.setDoc(gBrowser.contentDocument);				
			}
		}
		scriptCache = {};
		docCache = {};
		docCache[aURI.spec] = true;
	},
	//nsIWebProgressListener
	QueryInterface: XPCOMUtils.generateQI(["nsIWebProgressListener",
	                                       "nsISupportsWeakReference"
	                                       ]),

	                                       onLocationChange: function (aProgress, aRequest, aURI) {
		//dump1("User moves to new location\n");
		this.processNewURL(aURI, aRequest);
	},
	onStateChange: function () {},
	onProgressChange: function () {},
	onStatusChange: function () {},
	onSecurityChange: function () {}
};


if (typeof XULSchoolChrome === "undefined")
	var XULSchoolChrome = {};




function mkLabel(id, text, prop, off_func) {
	var on_func;
	if (typeof prop === "function")
		on_func = prop;
	return function() {
		var element = document.getElementById(id);
		var label = element.getAttribute("label");
		if (label === ("Turn Off " + text)){
			if (on_func)
				off_func();
			else
				window[prop] = false;
			element.setAttribute("label", "Turn On " + text);
		}
		else if (label === ("Turn On " + text)){
			if (on_func)
				on_func();
			else
				window[prop] = true;
			element.setAttribute("label", "Turn Off " + text);
		} else
			throw Error("Label '" + label + "' unrecognized");
	};
}

Cu.import("resource://gre/modules/XPCOMUtils.jsm");
(function() {
	var prefs = Cc["@mozilla.org/preferences-service;1"]
	.getService(Ci.nsIPrefService)
	.getBranch("extensions.adsapp.");
	prefs.addObserver("enabled", {
		observe: function(subject, topic, data) {
		if (topic === "nsPref:changed" && data === "enabled") {
			var val = prefs.getBoolPref("enabled");
			if (val === ads_app_is_enabled)
				return;
			XULSchoolChrome.BrowserOverlay.switchAds_app();
		}
	}
	}, false);


	XULSchoolChrome.BrowserOverlay = {
		switchAds_app: mkLabel("ads-item", "JaTE", function() {
			ads_app_is_enabled = true;
			prefs.setBoolPref("enabled", true);
		}, function() {
			ads_app_is_enabled = false;
			prefs.setBoolPref("enabled", false);
		}),
		switchBeautifier: mkLabel("beautifier-item", "JS Beautifier", "beautifier_is_enabled"),
		switchConfineAll: mkLabel("confine-item", "Confine All", "confineAll"),
		switchUseAdBlock: mkLabel("adblock-item", "AdBlock", "useAdBlock"),
		switchPolicyEnabled: mkLabel("policy-item", "Policies", "policyEnabled"),
		switchLogPolicyEnabled: mkLabel("logpolicy-item", "Log Policies", "logPolicyEnabled"),
		switchConfineInlineAds: mkLabel("inlineAds-item", "Confine Inline Ads", "confineWithRegex"),
	};



	// add a function to web content to simplify and speed up code
	var obs = Cc["@mozilla.org/observer-service;1"]
	.getService(Ci.nsIObserverService);
	obs.addObserver({
		QueryInterface: XPCOMUtils.generateQI([Ci.nsIObserver]),
		observe: function(subject, topic, data) {
			//dump("top:"+(XPCNativeWrapper.unwrap(subject)==XPCNativeWrapper.unwrap(subject).top)+ "window:"+XPCNativeWrapper.unwrap(subject)+"\n")
			if (data.indexOf("http") !== 0 || subject.top !== subject) {
				return;
			}
			var docWin = XPCNativeWrapper.unwrap(subject);
			docWin.ads_getDomain = getDomain;
			docWin.ads_rewriteFunction =  rewriteFunction;
			docWin.ads_rewriteThis = rewriteThis;
			docWin.ads_rewriteEval = rewriteEval;
			docWin.ads_docWrite = do_docWrite;
			docWin.ads_confine = confineAdsrc;
			docWin.ads_getConfineAll = function() { return confineAll; };
			docWin.ads_getSource = getSource;
			docWin.ads_setDomainToConfine = setDomainToConfine;
			docWin.ads_getPolicyEnabled = function() { return policyEnabled; };
			docWin.ads_getLogPolicyEnabled = function() { return logPolicyEnabled; };		
		}
	}, "content-document-global-created", false);



	Cu.import("resource://gre/modules/Services.jsm");
	let console = (Cu.import("resource://gre/modules/devtools/Console.jsm", {})).console;

	var policy =
	{
	  classDescription: "Test content policy",
	  classID: Components.ID("{12345678-1234-1234-1234-123456789abc}"),
	  contractID: "@sunysb.edu/test-policy;1",
	  xpcom_categories: ["content-policy"],

	  shouldLoad: function(contentType, contentLocation, requestOrigin, node, mimeTypeGuess, extra)
	  {
	  	if (!contentLocation)
	  		return Ci.nsIContentPolicy.ACCEPT;
//	  	else{
//	  		console.log("Loading " + contentLocation.spec + "    " + Ci.nsIContentPolicy.TYPE_SCRIPT);
//	  	}
		if (contentType === Ci.nsIContentPolicy.TYPE_SCRIPT){
			scriptCache[contentLocation.spec] = true;
		}
		else if (contentType === Ci.nsIContentPolicy.TYPE_DOCUMENT || contentType === Ci.nsIContentPolicy.TYPE_SUBDOCUMENT)
			docCache[contentLocation.spec] = true;
	    return Ci.nsIContentPolicy.ACCEPT;
	  },

	  shouldProcess: function(contentType, contentLocation, requestOrigin, node, mimeTypeGuess, extra)
	  {
	    return Ci.nsIContentPolicy.ACCEPT;
	  },

	  // nsIFactory interface implementation
	  createInstance: function(outer, iid)
	  {
	    if (outer)
	      throw Cr.NS_ERROR_NO_AGGREGATION;
	    return this.QueryInterface(iid);
	  },

	  // nsISupports interface implementation
	  QueryInterface: XPCOMUtils.generateQI([Ci.nsIContentPolicy, Ci.nsIFactory])
	};

    var registrar = Components.manager.QueryInterface(Ci.nsIComponentRegistrar);
    registrar.registerFactory(policy.classID, policy.classDescription, policy.contractID, policy);

    var catMan = Cc["@mozilla.org/categorymanager;1"].getService(Ci.nsICategoryManager);
	catMan.addCategoryEntry("content-policy", policy.contractID, policy.contractID, false, true);
	if (!AdBlockPlus)
		AdBlockPlus = Cu.import(Cc["@adblockplus.org/abp/public;1"].getService(Ci.nsIURI).spec, null).AdblockPlus;

})();
