var fileT = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

function readFile(filePath) {
    var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);

    fileT.initWithPath(filePath);
    if (fileT.exists() === false) {
        dump1("File does not exist\n");
    }

    fstream.init(fileT, 0x01, 0004, null);
    sstream.init(fstream);

    var output = sstream.read(sstream.available());
    sstream.close();
    fstream.close();
    return output;
}

function createFile(filePath) {
    dump("Creating file " + filePath + "\n");
    Components.utils.import("resource://gre/modules/FileUtils.jsm");
    try {
        fileT.initWithPath(filePath);
    } catch (err) {
        dump("FILE CREATION Error description: " + err.message + "\n");
    }
    if (fileT.exists() == false) {
        try {
            fileT.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
            dump(filePath + " should be created\n");
        } catch (err) {
            dump("FILE CREATION Error description: " + err.message + "\n");
        }
    }
}

function writeToFile(data, filePath) {
    fileT.initWithPath(filePath)
    if (fileT.exists() == false) {
        dump1("File does not exist\n");
    }

    foStream.init(fileT, 0x02 | 0x10, 00666, 0);
    foStream.write(data, data.length);
    foStream.close();
}

function removeFile(filePath){
	fileT.initWithPath(filePath)
    if (fileT.exists()) {
        fileT.remove(false);
    }

}
