var ads_app;
if (!ads_app){
	ads_app = {};
}

ads_app.onDebug = false;  // for debug purpose


// this general function rewrites JavaScript src which simply replaces
// a string origS (can be a function that returns a string)
// with another string newS (can be a function that returns a string)
// skipC (function) skips specific code
// By default: avoid following areas:
// 1. Comments
// 2. Inside quotations (code inside quotes will be rewritten later if 
// executed with eval, Function, setTimeout or setInterval.
ads_app.rewrite = function(src, origS, newS, skipC){
	var result='';
	var index = 0;
	var spaces = {'\u0009':true, '\u000B':true, '\u000C':true, '\u0020':true, '\u00A0': true};
	var lineTerminator = {'\u000A':true, '\u000D':true, '\u2028':true, '\u2029':true};
	var origSCallNo = 0;
	var newSCallNo = 0;
	var skipCCallNo = 0;
	var sLength = src.length;
	var lastNonSpaceChar = ';';

	while (index < sLength){
		var currentIndex = index;
		var os = (typeof origS === "string")?origS:origS(origSCallNo++, index);
		var nextIndex;
		if (skipC){
			var afterSkip = skipC(skipCCallNo++, index, result, src);//skip specific code defined by a specific rewriter					
			index = afterSkip.index;
			result = afterSkip.result;
			
		}

		if (src[index]==='/' && src[index+1] ==='*'){//skip block comment
			//if (ads_app.onDebug) dumpProxy("Skip block comment "+ sLength + " " + index + "\n");
			//if (ads_app.onDebug) dumpProxy(src.substring(index-20, index+20)+"\n");
			result = result + '/*';
			index = index + 2;

			while(!(src[index]=='*' && src[index+1]==='/') && index < sLength){
				result = result + src[index];
				index++;
			}

			if (index<sLength){
				result = result + src[index];
				index++;
			}

			if (index<sLength){
				result = result + src[index];
				index++;
			}
		}

		if (src[index]==='/' && src[index+1] ==='/'){//skip line comment
			//if (ads_app.onDebug) dumpProxy("Skip line comment "+ sLength + " " + index + "\n");
			//if (ads_app.onDebug) dumpProxy(src.substring(index-20, index+20)+"\n");
			result = result + '//';
			index = index + 2;

			while(!lineTerminator[src[index]] && index < sLength){
				result = result + src[index];
				index++;
			}				

			if (index<sLength){
				result = result + src[index];
				index++;
			}
		}
		
		if (src[index]==='/' && index+1<sLength && src[index+1] !=='/' && src[index+1] !=='*'){//skip regular expression
			var beforeChar = {"{":true, "(":true, "*":true, "&":true, 
					"^":true, "%":true, "!":true, "/":true, "-":true, "+":true, "=":true, "~":true, "|":true, "[":true,
					"<":true, ">":true, ":":true, ";":true, "?":true};
			var spaces = {'\u0009':true, '\u000B':true, '\u000C':true, '\u0020':true, '\u00A0': true};
			var nIndex = index-1;					
			
			while (nIndex>0 && (spaces[src[nIndex]] || lineTerminator[src[nIndex]])){
				nIndex--;
			}
			
			// src[nIndex] is the last non-space charater. We have to make
			// sure that we it is not math divident operand
			if (nIndex===0 || beforeChar[src[nIndex]]){ // now we can skip the regular expression						
				//dump(src.substring(index-20, index+20)+"\n");
				result = result + '/';
				index = index + 1;
				var cont = true;
				
				while(cont){
					if (index<sLength && src[index]==='/'){
						var slashCount = 0;
						var sIndex = index-1;
						while (sIndex>=0 && src[sIndex]==='\\'){//handle the case '\\\''
							slashCount++;
							sIndex--;
						}						
						if (slashCount%2===0){
							cont = false;							
						}
						else{
							result = result + src[index];
							index++;
						}
					}
					else if (index<sLength){
						result = result + src[index];
						index++;
					}	
				}
				
				if (index<sLength){					
					result = result + src[index];
					index++;
				}
			}
		}

		if (src[index]==="'"){//skip text inside single quotes
			//if (ads_app.onDebug) dumpProxy("Skip text inside single quotes "+ sLength + " " + index + "\n");
			//if (ads_app.onDebug) dumpProxy(src.substring(index-20, index+20)+"\n");
			result = result + "'";
			index = index + 1;
			var cont = true;

			while(cont){	
				//if (ads_app.onDebug) dumpProxy(sLength + " " + index + " " + src[index] + "\n");
				if (index<sLength && src[index]==="'"){
					var slashCount = 0;
					var sIndex = index-1;
					while (sIndex>=0 && src[sIndex]==='\\'){//handle case string has form '\\\''
						slashCount++;
						sIndex--;
					}						
					if (slashCount%2===0){
						cont = false;							
					}
					else{
						result = result + src[index];
						index++;
					}
				}
				else if (index<sLength){
					result = result + src[index];
					index++;
				}						
			}				

			if (index<sLength){					
				result = result + src[index];
				index++;
			}					
		}

		if (src[index]==='"'){//skip text inside double quotes
			//if (ads_app.onDebug) dumpProxy("Skip text inside double quotes "+ sLength + " " + index + "\n");
			//if (ads_app.onDebug) dumpProxy(src.substring(index-20, index+20)+"\n");
			result = result + '"';
			index = index + 1;
			var cont = true;

			while(cont){
				if (index<sLength && src[index]==='"'){
					var slashCount = 0;
					var sIndex = index-1;
					while (sIndex>=0 && src[sIndex]==='\\'){//handle case string has form '\\\''
						slashCount++;
						sIndex--;
					}						
					if (slashCount%2===0){
						cont = false;							
					}
					else{
						result = result + src[index];
						index++;
					}
				}
				else if (index<sLength){
					result = result + src[index];
					index++;
				}						
			}				

			if (index<sLength){					
				result = result + src[index];
				index++;
			}
		}					

		nextIndex = index + os.length;

		if (nextIndex < src.length && src.substring(index, nextIndex) === os){ 
			//find a match for origS				
			var dec = newS(newSCallNo++, index, result, src);
			index = dec.index; // next index to proccess
			result = dec.result;
		}
		
		if (index<src.length && currentIndex===index){
			result = result + src[index];
			index++;
		}
	}		
	return result;
};

//rewrite 'eval'
ads_app.rewriteEval = function(src){		
	var beforeChar = {"}":true, "{":true, ")":true, "(":true, "*":true, "&":true, 
			"^":true, "%":true, "!":true, "/":true, "-":true, "+":true, "=":true, "~":true, "|":true, "[":true, "]":true,
			"<":true, ">":true, ":":true, ";":true, "?":true, ",":true};	
	var spaces = {'\u0009':true, '\u000B':true, '\u000C':true, '\u0020':true, '\u00A0': true};
	var lineTerminator = {'\u000A':true, '\u000D':true, '\u2028':true, '\u2029':true};

	var newS = function(newSCallNo, index, result, src){
		var dec = {};
		var bc = src[index-1];		
		if (bc ===undefined || beforeChar[bc] || spaces[bc] || lineTerminator[bc]){//before character
			index = index + 4;
			var sps = '';
			while ((spaces[src[index]] || lineTerminator[src[index]]) && index<src.length){//skip spaces and line terminators;
				sps = sps + src[index];
				index++;
			}				

			if (src[index] === '('){ 				
				var count = 1;
				var evalSrc = '';
				index++;
				while (index < src.length && count>0){
					//we should to skip comments in this, but maybe very unlikely 						
					if (src[index] === ')'){
						count--;
					}
					if (src[index] === '('){
						count++;
					}										
					if (count>0) evalSrc = evalSrc + src[index];
					index++;
				}
				//result = result + 'ads_app.safeEval' + sps + '(' + evalSrc + ')';
				result = result + 'eval' + sps + '(ads_app.processEvalSrc(' + evalSrc + '))';
			}
			else{
				result = result + 'eval' + sps; 
			}				
		}
		dec.index = index;
		dec.result = result;			
		return dec;
	};

	return ads_app.rewrite(src, 'eval', newS);		
};

//replace all appearance of 'this'
ads_app.rewriteThis = function(src){		
	var beforeChar = {"}":true, "{":true, ")":true, "(":true, "*":true, "&":true, 
			"^":true, "%":true, "!":true, "/":true, "-":true, "+":true, "=":true, "~":true, "|":true, "[":true, "]":true,
			"<":true, ">":true, ":":true, ";":true, "?":true, ",":true};
	var afterChar = {".":true, "}":true, "{":true, ")":true, "(":true, "*":true, "&":true, 
			"^":true, "%":true, "!":true, "/":true, "-":true, "+":true, "=":true, "~":true, "|":true, "[":true, "]":true,
			"<":true, ">":true, ":":true, ";":true, "?":true, ",":true};
	var spaces = {'\u0009':true, '\u000B':true, '\u000C':true, '\u0020':true, '\u00A0': true};
	var lineTerminator = {'\u000A':true, '\u000D':true, '\u2028':true, '\u2029':true};

	var newS = function(newSCallNo, index, result, src){
		var dec = {};
		var bc = src[index-1];
		var ac = src[index+4];
		if ((bc ===undefined || beforeChar[bc] || spaces[bc] || lineTerminator[bc])
				&& ((ac ===undefined || afterChar[ac] || spaces[ac] || lineTerminator[ac]))){// check before and after charaters				
			if (src.substring(index-4,index) === 'new '){ // deal with code 'new this()'
				result = result + '(this===realSecretWindow?window:this)';
			}
			else{
				result = result + 'ads_processThis(this)';
			}
			index = index + 4;
		}
		else{
			result = result + 'this';
			index = index + 4;
		}
		dec.index = index;
		dec.result = result;
		return dec;
	};

	return ads_app.rewrite(src, 'this', newS);		
};
