// Helper function for XPCOM instanciation (from Firebug)
function CCIN(cName, ifaceName) {
    return Cc[cName].createInstance(Ci[ifaceName]);
}
// Copy response listener implementation.
function TracingListener() {
    this.originalListener = null;
    this.notificationFunc = null;
    this.receivedData = [];   // array for incoming data.
	this.url = null;
	this.contentType = null;
	this.originalURL = null;
	this.domain = null;
	this.hostDomain = null;
	this.hostURL = null; 
	this.jswrote = false;
	this.offset = 0;
	this.uid = 0;
	this.window = null;
    this.stopMode = null;
    this.adsInjected = false;
    this.isScriptAd = false;
}

TracingListener.prototype =
{
	computeSrc: function(src1, src2){
		var newSrc =
			"//dump('Processing '+'" + this.originalURL + "'+'\\n');"			
			+"\n"+
			"var ads_setup_builtIn_functions;"
			+"\n"+
			"var ads_src = document.documentElement.getAttribute('" + this.uid + "');"
			+"\n"+
			"document.documentElement.removeAttribute('" + this.uid + "');"
			+"\n"+
			"var ads_app;"
			+"\n" +			
			"try {"
			+"\n"+			
			"	ads_app = top.ads_app;"
			+"\n"+			
			"}"
			+"\n"+
			"catch(e) {"
			+"\n"+
			"  	ads_app = undefined;"
			+"\n"+
			"  	//dump('%%Script from iframe  with different origin '+'" + this.originalURL +"' + ' ==> ' +  window.location.href + '\\n');"			
			+"\n"+
			"}"			
			+"\n"+
			"if (ads_app!==undefined){"
			+"\n"+
			"	//ads_app.setupPolicy(window,'" + this.domain + "');"
			+"\n"+
			"	if (" + this.isScriptAd +")"
			+"\n"+
			"		ads_app.adDomains['" + this.domain + "'] = 1;"
			+"\n"+
			"   ads_app.confineScripts++;"
			+"\n"+
			"   ads_app.confineSize = ads_app.confineSize + " + src1.length +  ";" 
			+"\n"+
			src1
			+"\n"+
			"}"
			+"\n"+
			"else {"
			+"\n"+
			"	//dump('===>Running iframe code ' + ads_src.substring(0,30) + '\\n');"
			+"\n"+
			"  // ads_app_notConfineSize = ads_app_notConfineSize + " + src1.length +  ";" 
			+"\n"+
			"	eval(ads_src);" 
			+"\n"+
			"}";
		return newSrc;
	},
	
    onDataAvailable: function(request, context, inputStream, offset, count)
    {

		this.request = request;
		this.context = context;

		var binaryInputStream = CCIN("@mozilla.org/binaryinputstream;1",
                "nsIBinaryInputStream");
        binaryInputStream.setInputStream(inputStream);
        
        // Copy received data as they come.
        var data = binaryInputStream.readBytes(count);
		
        if (ads_app_is_enabled && !this.adsInjected && (docCache[request.originalURI.spec] || docCache[request.URI.spec]) && this.contentType && this.contentType.indexOf("html") > 0){
        	//dump("writing html of " + this.url + "\n");
    	    //Modify main page head tag to include ads.js
            request.setResponseHeader("X-AD-PROCESS", "html", false);
        	var includedScript = ads_app_js;
        	if (aSession.getURL() !== this.url){
        		includedScript = '';//ads_app_js_frame;
        	}
        		
    		var bIndex = data.indexOf("<head");
    		var bbIndex = data.indexOf(">", bIndex);
    		if (bIndex >=0){
    			this.adsInjected = true; // to avoid injecting ads script twice
    			data = data.splice(bbIndex+1, 0, includedScript);
    			count = count + includedScript.length;			
        	}
        }
        
        if (ads_app_is_enabled && confineAll && (docCache[request.originalURI.spec] || docCache[request.URI.spec]) && this.contentType && this.contentType.indexOf("html") > 0 && aSession.getURL() === this.url) {
            this.stopMode = "docwrite";
            this.receivedData.push(data);
            request.setResponseHeader("X-AD-PROCESS", "docwrite", false);
        } else if ((scriptCache[this.url] || (this.contentType && this.contentType.indexOf("javascript") > 0))
        		&& this.domain !== 'tunghackserver.com') {
            this.stopMode = "js";
            this.receivedData.push(data);
            request.setResponseHeader("X-AD-PROCESS", "js", false);
        } else {        	
			// docwrite is off and the content is not javascript nor html => just stream it
            var storageStream = CCIN("@mozilla.org/storagestream;1", "nsIStorageStream");
            var binaryOutputStream = CCIN("@mozilla.org/binaryoutputstream;1",
                "nsIBinaryOutputStream");
		    storageStream.init(8192, count, null);
            binaryOutputStream.setOutputStream(storageStream.getOutputStream(0));	
            binaryOutputStream.writeBytes(data, count);
			try{
				this.originalListener.onDataAvailable(request, context, storageStream.newInputStream(0), this.offset, count);
		        this.offset = this.offset + count;
            }
            catch(e){
                //alert(this.originalURL);
            }
        }
    },

    onStartRequest: function(request, context) {    
    	try{
    		this.originalListener.onStartRequest(request, context);
    	}
    	catch(e){};
    },

    onStopRequest: function(request, context, statusCode)
    {
        var responseSource = this.receivedData.join("");
        if (this.stopMode === "js"){
        	//dump(">>>JS Rewriting of " + this.url + "\n");          
        	//dump("FROM PAGE:" + this.window.document.documentElement.untrusteddomains +"\n");         
        	// Get entire response
        	var utf8 = String.fromCharCode(0xef)+String.fromCharCode(0xbb)+String.fromCharCode(0xbf);
        	responseSource = responseSource.replace(utf8, "");

        	if (ads_app_is_enabled && (confineAll || this.domain !== this.hostDomain)){
        		//dump("JS is being rewritten\n");
        		// to enable execution of original JS source if not confined
        		this.uid = aSession.getScriptUID();
        		//aSession[this.originalURL] = responseSource;  
        		
        		if (this.window){	
        			try{
        				this.window.document.documentElement.setAttribute(this.uid, responseSource);
        			}
        			catch(e){
        				//alert('BADWRITE ' + this.url + ' ' + this.window.document);
        			}
        		}

        		var confinedSrc = confineAdsrc(responseSource, this.domain, this.originalURL, 1);
        		responseSource = this.computeSrc(confinedSrc, responseSource);        			    			
        	}

        	if (beautifier_is_enabled){
        		responseSource = js_beautify(responseSource); //beautify JS source code for debugging purposes
        	}

        } else if (this.stopMode === "docwrite") {
        	//dump(">>>HTML Rewriting of " + this.url + "\n");          
        	responseSource = do_docWrite(responseSource, this.domain, "html");
        }
        else{
        	
        }

        //setup response buffer
        var storageStream = CCIN("@mozilla.org/storagestream;1", "nsIStorageStream");
        var binaryOutputStream = CCIN("@mozilla.org/binaryoutputstream;1", "nsIBinaryOutputStream");
        var count = responseSource.length;
        storageStream.init(8192, count, null);
        binaryOutputStream.setOutputStream(storageStream.getOutputStream(0));
        try{
        	binaryOutputStream.writeBytes(responseSource, count);
        	// forward onDataAvailable of accumulated response to original listener
        	this.originalListener.onDataAvailable(this.request, this.context, storageStream.newInputStream(0), 0, count);       
        }
        catch(e){
        	//if (count >0){
        	//dump('>>>Buffer writing problem:' + e.message + " --> length:" + count + ", url:" + this.originalURL + "\n");
        	//}
        }

        //dump('done get request for ' + this.url + ' >>time:'+ ((new Date().getTime()) - aSession.startTime) +"\n");

        // forward onStopRequest to original listener
        try{
        	this.originalListener.onStopRequest(request, context, statusCode);
        }
        catch(e){
        	//dump('>>>onStopRequest problem:' + e.message + ", url:" + this.originalURL + "\n");
        	return;
        }
    },
    
    QueryInterface: function (aIID) {
        if (aIID.equals(Ci.nsIStreamListener) ||
            aIID.equals(Ci.nsISupports)) {
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    }
}
