/*jshint camelcase:false, plusplus:false, proto:true, evil:true, esnext:true, moz:true, unused: vars */
/*global Cc, Ci, Cr, AdBlockPlus, docCache, scriptCache, confineAdsrc, ads_app_is_enabled, beautifier_is_enabled, confineAll, useAdBlock, aSession, ads_app_js, ads_app_js_frame, js_beautify, dump, getDomainToConfine, string_splice, adsBlockPlusMore, do_docWrite, confineWithRegex, inlineRegex, inlineRegexes */

// Helper function for XPCOM instanciation (from Firebug)
function CCIN(cName, ifaceName) {
    return Cc[cName].createInstance(Ci[ifaceName]);
}

// Copy response listener implementation.
function TracingListener() {
    this.originalListener = null;
    this.notificationFunc = null;
    this.receivedData = [];   // array for incoming data.
	this.url = null;
	this.contentType = null;
	this.originalURL = null;
	this.domain = null;
	this.hostDomain = null;
	this.hostURL = null; 
	this.jswrote = false;
	this.offset = 0;
	this.uid = 0;
	this.window = null;
    this.buffering = null;
    this.adsInjected = false;
    this.isScriptAd = false;
}

TracingListener.prototype =
{
	computeSrc: function(src1){
		var newSrc =			
			"var ads_app;\n" +
			"try {\n" +
			"	ads_app = top.ads_app;\n" +
			"}\n" +
			"catch(e) {\n" +
			"  	ads_app = undefined;\n" +
			"  	//dump('%%Script from iframe  with different origin '+'" + this.originalURL +"' + ' ==> ' +  window.location.href + '\\n');\n" +		
			"}\n" +
			"if (ads_app!==undefined){\n" +			
			"   ads_app.confineScripts++;\n" +
			"   ads_app.confineSize = ads_app.confineSize + " + src1.length +  ";\n" +
			src1 + "\n" +
			"}\n" +
			'else{\n' +
			'  var codeToBeConfined = window["' + this.uid + '"];\n' +
			'  delete window["' + this.uid + '"];\n' +			
			'  eval(codeToBeConfined);\n' +
			'}\n';	
		return newSrc;
	},
	
    onDataAvailable: function(request, context, inputStream, offset, count)
    {
    	this.request = request;
		this.context = context;


        // Copy received data as they come.
        var data = "", isFinal = false;
        var binaryInputStream = CCIN("@mozilla.org/binaryinputstream;1",
                "nsIBinaryInputStream");
        if (inputStream) { // fast buffering can call this method with inputStream = null and count = 0
            binaryInputStream.setInputStream(inputStream);        
            data += binaryInputStream.readBytes(count);
        }
        if (this.buffering === "fast") {
            data = this.receivedData.shift() + data;
            count = data.length;
            this.buffering = "";
            isFinal = true;
        }

        var isHTML = (docCache[request.originalURI.spec] || docCache[request.URI.spec]) && this.contentType && this.contentType.indexOf("html") > 0; 
        
        if (!this.adsInjected && isHTML && ads_app_is_enabled){        	
    	    //Modify main page head tag to include ads.js
            request.setResponseHeader("X-AD-PROCESS", "html", false);
        	var includedScript = ads_app_js;
        	if (aSession.getURL() !== this.url){
        		includedScript = ads_app_js_frame;
        	}
        		
    		var bIndex = data.indexOf("<head");
    		if (bIndex<0){
    			bIndex = data.indexOf("<HEAD");
    		}
    		var bbIndex = data.indexOf(">", bIndex);
    		if (bIndex >=0){
    			this.adsInjected = true; // to avoid injecting ads script twice
    			data = string_splice(data, bbIndex+1, 0, includedScript);
    			count = count + includedScript.length;    			
        	}
    		
        }

         
        if (isHTML && confineWithRegex && (count > 10000 || isFinal)) {
            var that = this;
            data = data.replace(inlineRegex, function(m) {
                var args = Array.slice(arguments, 0);
                args.shift();
                var firstGroup;
                args = args.filter(function(el, i) {
                    if (!firstGroup && el !== "")
                        firstGroup = i;
                    return el !== "";
                });
                var [before, src, after] = args;
                firstGroup = Math.floor(firstGroup / 3); // use the first non-null group to get the index
                var adDomain = inlineRegexes[firstGroup][0];
                console.log("Found inline ad", before, src, after, adDomain);
                return before + confineAdsrc(src, adDomain + "-inline", that.url) + after;
            });
            count = data.length;
        } else if (!isFinal && isHTML && confineWithRegex && data.length <= 10000 && !confineAll) {
            this.buffering = "fast"; // special faster case for confineWithRegex, need big chunks
            this.receivedData.push(data);
            return;
        }
        
        //dump("Comparing "+ aSession.hostDomain + "    "  + this.url + "   " + (aSession.hostDomain === getDomain(this.url)));
        //&& aSession.hostDomain === getDomain(this.url)
        if (ads_app_is_enabled  && confineAll  && isHTML 
            && (docCache[request.originalURI.spec] || docCache[request.URI.spec])) {
            this.buffering = "docwrite";
            this.receivedData.push(data);
        } else if (ads_app_is_enabled &&
                   ((scriptCache[this.url]) && this.domain !== "www.tunghackserver.com")) {
            this.buffering = "js";
            this.receivedData.push(data);
        } else {        	
			// docwrite is off and the content is not javascript nor html => just stream it
            this.writeData(data);
        }
    },

    onStartRequest: function(request, context) {    
    	try{
    		this.originalListener.onStartRequest(request, context);
    	} catch(e) { }
    },

    onStopRequest: function(request, context, statusCode)
    {
    	//console.log(">>>onStopRequest: " + this.buffering + "    "  + this.url + "\n");
    	
        if (this.buffering === "fast") {
            this.onDataAvailable(this.request, this.context, null, this.offset, 0);
        }

        var responseSource = this.receivedData.join("");
        this.uid = aSession.getScriptUID();
        if (this.buffering === "js"){
        	//console.log(">>>JS Rewriting of " + this.url + "\n");          

        	// Get entire response
    		var utf8 = String.fromCharCode(0xef)+String.fromCharCode(0xbb)+String.fromCharCode(0xbf);
    		responseSource = responseSource.replace(utf8, "");
    		
    		var aSrc = aSession.rewrittenSources[this.url];
			if (aSrc){
				responseSource = aSrc;
			}
			else{
				responseSource = confineAdsrc(responseSource, getDomainToConfine(request.URI.spec),{window:this.window, uid:this.uid, url:this.url});
			}
			                
    		if (beautifier_is_enabled){
    			responseSource = js_beautify(responseSource); //beautify JS source code for debugging purposes
    		}

		} else if (this.buffering === "docwrite")  {
			dump("HOST: " + aSession.hostURL+"\n");
			dump("REWRITE " + this.url+"\n");
			var aSrc = aSession.rewrittenSources[this.url];
			if (aSrc){
				responseSource = aSrc;
			}
			else{
				responseSource = do_docWrite(responseSource, this.domain, {html: confineAll}, {window:this.window, uid:this.uid, url:this.url});
			}
			
		}

        //setup response buffer
        if (responseSource) {
            this.writeData(responseSource);
		}
        // forward onStopRequest to original listener
        try{
        	this.originalListener.onStopRequest(request, context, statusCode);
        }
        catch(e){
        	//dump('>>>onStopRequest problem:' + e.message + ", url:" + this.originalURL + "\n");
        }
    },

    writeData: function(data) {
        var storageStream = CCIN("@mozilla.org/storagestream;1", "nsIStorageStream");
        var binaryOutputStream = CCIN("@mozilla.org/binaryoutputstream;1", "nsIBinaryOutputStream");
        var count = data.length;
        storageStream.init(8192, count, null);
        binaryOutputStream.setOutputStream(storageStream.getOutputStream(0));
        try {
            binaryOutputStream.writeBytes(data, count);
            this.originalListener.onDataAvailable(this.request, this.context, storageStream.newInputStream(0), 0, count);
            this.offset = this.offset + count;
        }
        catch(e){
            //if (count >0){
            //dump('>>>Buffer writing problem:' + e.message + " --> length:" + count + ", url:" + this.originalURL + "\n");
            //}
        }
    },
    
    QueryInterface: function (aIID) {
        if (aIID.equals(Ci.nsIStreamListener) ||
            aIID.equals(Ci.nsISupports)) {
            return this;
        }
        throw Cr.NS_NOINTERFACE;
    }
};