/*jshint camelcase:false, plusplus:false, proto:true, evil:true, esnext:true, moz:true, unused: vars */
/*global dump, ads_getConfineAll, ads_getPolicyEnabled, ads_rewriteFunction, ads_rewriteThis, ads_rewriteEval, ads_docWrite, ads_confine, ads_getLogPolicyEnabled, Iterator, MozNamedAttrMap, Attr */
var WeakMapPlus = function() {
	this.w = new WeakMap();
	this.a = [];
	this.b = [];
};

WeakMapPlus.prototype = {
	get: function(obj) {
		var wo = this.w.get(obj);
		if (wo)
			return wo;
		for (var i = 0; i < this.a.length; i++) {
			if (obj === this.a[i])
				return this.b[i];
		}
		return undefined;
	},
	set: function(obj, val) {
		try {
			return this.w.set(obj, val);
		} catch(e) {
			for (var i = 0; i < this.a.length; i++) {
				if (obj === this.a[i]) {
					this.b[i] = val;
					return this;
				}
			}
			this.a.push(obj);
			this.b.push(val);
			return this;
		}
	},
	has: function(obj) {
		return this.w.has(obj) || ads_app.array_filter.call(this.a, function(o) { return o === obj; }).length > 0;
	},
	getOrCreate: function(obj, def) {
		var result = this.get(obj);
		if (result === undefined) {
			this.set(obj, def);
			return def;
		}
		return result;
	}
};

  

var ads_app = {
	onDebug: false,
	disableDocWrite: false,
	addLog: true,
	contextDebugOn:false,
	context:[], // context stack
	eContext:[], // effective principal context stack
	scriptGenTree:{}, // the script generation tree
	processedScripts: new WeakMap(), // keep track of processed scripts
	contextNum:0,

	// some references to original prototype functions used in ads_app
	originalError: Error,
	originalObject: Object,
	originalFunctionPrototype_bind: Function.prototype.bind,
	getOwnPropertyDescriptor: Object.getOwnPropertyDescriptor,
	getOwnPropertyNames: Object.getOwnPropertyNames,
	defineProperty: Object.defineProperty,
	getPrototypeOf: Object.getPrototypeOf,
	keys: Object.keys,
	functionToString: Function.prototype.toString,
	functionCall: Function.prototype.call,
	objectToString: Object.prototype.toString,
	objectCreate: Object.create,
	origObjProto_hasOwnProperty:  Object.prototype.hasOwnProperty,
	seal: Object.seal,
	freeze: Object.freeze,
	preventExtensions: Object.preventExtensions,
	isArray:  Array.isArray,
	array_filter: Array.prototype.filter,
	array_slice: Array.prototype.slice,
	array_foreach: Array.prototype.forEach,
	array_map: Array.prototype.map,
	string_split: String.prototype.split,
	originalString: String,
	originalDocWrite: document.write,
	originalEval: eval,

	objectToDomain: new WeakMapPlus(), // used to store object origin

	mapD2W: new WeakMapPlus(), // store map from dry to wet objects, for map between dry and wet
	mapW2D: new WeakMapPlus(), // store map from wet to dry objects, for map between dry and wet

	domNodeOwner: new WeakMap(), // store real DOM node owner	
	domNodeAction: new WeakMap(), // store actions related to DOM nodes
	objParent: new WeakMap(), // store parent of object (e.g. Attr -> DOM Node) for policy checks

	noLogList: new WeakMap(),
	logRecords: [], // log all actions
	opOrder:0, // log order

	docWriteState: {},
	debugNo: 0, // used by rewriteDebug

	windowLoaded: false,
	currentElm:"", // used for docwrite region detection	
	domainRewriteDocWrite:[], // used to store domains rewriting docwrite
	latestdocwrite:{}, // used to store last definition of docwrite in case it is rewritten
	latestdocwriteln:{}, // used to store last definition of docwrite in case it is rewritten

	mapFromDomainToDivs: {}, // store regions assigned to ads domain

	adDomains:{}, // store ads domains

	// for statistics
	confineScripts: 0,
	confineSize: 0,

	logPolicyPaths: new WeakMapPlus(),

	
	//for shadow policy
	shadowMap: new WeakMapPlus(), // map from direct object to an array of shadow objects (each principal has its own shadow object)

	scriptMap: new WeakMap(), // holds the principal running the script, so that it can always have rw access to the script node.
	
	init: function() {
		
		
		ads_app.hostDomain = ads_app.getDomain(window.location.href);
		ads_app.eHostDomain = ads_app.hostDomain; // check this one in the policy as it is immune to confineAll

		ads_app.docWriteContext = ads_app.hostDomain;
		ads_app.currentContext = ads_app.hostDomain; // initial context
		ads_app.effectiveContext = ads_app.hostDomain;
		

		if (ads_app.logPolicyEnabled) {
			ads_app.preLog("window");
			ads_app.preLog("Math");
			["Object", "RegExp", "Array", "String", "Function", "Date",
			 "Number", "Node", "Element", "Window", "Document"].forEach(function(n) {
				ads_app.preLog(n);
				ads_app.preLog(n + ".prototype");
			});
		}	

		window.addEventListener("load", function(){
			dump("\n######NSCRIPTS " + ads_app.confineScripts + "\n");
			dump("\n######SSCRIPTS " + ads_app.confineSize + "\n");
			ads_app.windowLoaded = true;
			ads_app.dumpScriptGenTree();
		}, false);

		
		ads_app.setupBuiltInFunctions(window);
		
		if (ads_app.policyEnabled) {
			ads_app.initPolicy();
		}
		
		
		
	},
	
	// transparent: if the script is from 'jate_transparent'
	// contextFromScript: if the context is entered from running new script code  
	enterContext: function(ctx, transparent){
		if (ads_app.policyEnabled) {
			ads_app.flushPolicies();
			var newctx = ads_app.domainToCompartment[ctx];
			if (newctx)
				ctx = newctx;
			else if (ads_app.domainToCompartment["*"] && ctx !== ads_app.eHostDomain)
				ctx = "untrusted";
		}
		if (!transparent){
			ads_app.eContext.push(ads_app.effectiveContext);
			ads_app.effectiveContext = ctx;			
		}		
		ads_app.context.push(ads_app.currentContext);
		ads_app.currentContext = ctx;	
	},

	exitContext: function(transparent){
		if (ads_app.policyEnabled)
			ads_app.flushPolicies();		
		if (!transparent)
			ads_app.effectiveContext = ads_app.eContext.pop();
		ads_app.currentContext = ads_app.context.pop();
	},
	
	// get shadow object of an object
	getShadowObj: function(obj, context){
		var shadows = ads_app.shadowMap.get(obj);		
		if (shadows){
			return shadows[context];			
		}					
		return undefined;
	},

	processEvalSrc: function(src){
		if (typeof src === "string"){
			if (src.indexOf("ads_app")>=0){
				return src; // TODO: is this reliable to detect already confined scripts? and why would they be already confined?
			}			
			src = ads_rewriteFunction(src);
			src = ads_rewriteThis(src);
			src = ads_rewriteEval(src);
		}
		return src;
	},		

	//set object origin for wet object
	setObjOrigin: function(obj, domain){
		if (ads_app.getObjOrigin(obj)!=="unknown"){ // if obj already had origin
			return;
		}
		ads_app.objectToDomain.set(obj, domain);				
	},

	//get object origin for wet object
	getObjOrigin: function(obj){
		var domain = ads_app.objectToDomain.get(obj);
		if (domain){
			return domain;
		}
		return "unknown";
	},

	//test if an obj is dry
	isDry: function(obj){ 
		return ads_app.mapD2W.has(obj);
	},

	//get wet object corresponding with dry object
	getWet: function(dry){ 
		var wet = ads_app.mapD2W.get(dry);		
		return wet?wet:dry;
	},

	// works even for primitives
	getWetP: function(dry) {
		return ads_app.isPrimitive(dry) ? dry : ads_app.getWet(dry);
	},

	//get dry object corresponding with wet object
	getDry: function(wet){
		if (ads_app.mapW2D.has(wet)){		
			return ads_app.mapW2D.get(wet);
		}
		return null;
	},


	//sync a property on shadow object and original object
	//we can do a light sync atm (later) 
	syncShadow:function(shadow, obj, n){
		try{
			var objDesc = ads_app.getOwnPropertyDescriptor(obj,n);
			var shadowDesc = ads_app.getOwnPropertyDescriptor(shadow, n);
			if (!shadowDesc || shadowDesc.configurable) {						
				if (objDesc.get || objDesc.set) {
					ads_app.defineProperty(shadow, n, {configurable:true, get:(objDesc.get?ads_app.originalFunctionPrototype_bind.call(objDesc.get,obj):undefined), set:(objDesc.set?ads_app.originalFunctionPrototype_bind.call(objDesc.set,obj):undefined), enumerable:objDesc.enumerable});
				} else {
					ads_app.defineProperty(shadow, n, {configurable:true, writable:true, value:objDesc.value, enumerable:objDesc.enumerable});
				}
			} else {
				shadow[n] = obj[n]; // TODO: check this, it was obj[e]
			}
		}
		catch(e){ // if there is a typeError here, it is possible that we are dealing with some built-in object, try to sync all properties
			var objProps = ads_app.getOwnPropertyNames(obj);
			objProps.forEach(function(e){
				var objDesc = ads_app.getOwnPropertyDescriptor(obj,e);
				var shadowDesc = ads_app.getOwnPropertyDescriptor(shadow, e);
				if (!shadowDesc || shadowDesc.configurable) {						
					if (objDesc.get || objDesc.set) {
						ads_app.defineProperty(shadow, e, {configurable:true, get:(objDesc.get?ads_app.originalFunctionPrototype_bind.call(objDesc.get,obj):undefined), set:(objDesc.set?ads_app.originalFunctionPrototype_bind.call(objDesc.set,obj):undefined), enumerable:objDesc.enumerable});
					} else {
						ads_app.defineProperty(shadow, e, {configurable:true, writable:true, value:objDesc.value, enumerable:objDesc.enumerable});
					}
				}
				else{
					shadow[e] = obj[e];
				}
			});
		}
	},


	// helper function to process return value in get trap
	// can be used in traps that behave like the get trap
	// callerContext: current caller context
	// calleeContext: context of callee
	processGetValue:function(result, callerContext, calleeContext){
		//Primitive type, do not need to wrap
		if (ads_app.isPrimitive(result)) {						
			if (ads_app.onDebug) dumpProxy("<-- 0-Return " + result + "\n");
			return result;
		}

		// this case handles document.all,
		// we always return false
		if (ads_app.documentAll.has(result)){
			if (ads_app.onDebug) dumpProxy("<-- 00-Return " + result + "\n");
			return false;
		}

		// do not wrap white-list objects, those objects can be used in a frame with 
		// the same origin as well				
		if (ads_app.whiteList.has(result)){
			if (ads_app.onDebug) dumpProxy("<-- 1-Return whitelist object\n");
			return result;
		}					

		// 1. If result is a dry object
		// 	  1.1. if result's corresponding wet object has origin the sasme as the current context
		//	then return the wet object
		//	  1.2  else return a dry object
		// 2. If result is a wet object, then propagate its origin, and return a dry object		
		var wetResult, resultOrigin;
		wetResult = ads_app.mapD2W.get(result);
		if (wetResult){ // result is dry							
			resultOrigin = ads_app.getObjOrigin(wetResult);

			// result's corresponding wet object has origin the same as the current caller context, i.e. it was created here,
			// except result is a native prototype object (prototype object should be dry for all contexts)
			if (resultOrigin===callerContext && !ads_app.nativePrototypeObjects.has(wetResult)){
				if (ads_app.onDebug) dumpProxy("<-- 2-Return wet object \n");
				return wetResult;
			}
			else{// caller context and result origin are different, then should return dry
				if (ads_app.onDebug) dumpProxy("<-- 3-Return dry object\n");
				return result;
			}
		}
		else { // result is wet 

			//result's origin is from calleeContext if it is unknown
			resultOrigin = ads_app.getObjOrigin(result);
			if (resultOrigin === "unknown"){
				resultOrigin = calleeContext;
				ads_app.setObjOrigin(result, resultOrigin);
			}

			// if caller context and result origin are the same, then return wet.
			// this can be possible and legitimate, e.g. String.prototype.match,
			// except result is a prototype object
			if (callerContext === resultOrigin && !ads_app.nativePrototypeObjects.has(result)){  
				if (ads_app.onDebug) dumpProxy("<-- 4-Return wet object \n");
				return result;
			}

			// else, return dry
			if (ads_app.onDebug) dumpProxy("<-- 5-Return the dry object \n");
			return ads_app.createProxy(result);
		}
	},

	// helper function to process 'value' in set trap
	// can be used in traps that behave like the set trap
	// calleeContext is obj's origin
	processSetValue: function(value, obj, callerContext, calleeContext){
		var finalValue = value;

		if (!ads_app.isPrimitive(value)){ //if value is not primitive

			//if value is whiteListed, then keep it wet
			if (ads_app.whiteList.has(value)){
				if (ads_app.onDebug) dumpProxy("<-- 0-Set to whitelisted wet object \n");
				return value;
			}

			var wetValue = ads_app.mapD2W.get(value);
			var valueOrigin;
			if (wetValue) {// value is a dry object					
				valueOrigin = ads_app.getObjOrigin(wetValue);

				//if obj is one of built-in native prototype objects
				//then we always keep value dry 	
				if (ads_app.nativePrototypeObjects.has(obj)){
					//alert("--->This site writes to prototype object " + ads_app.isDry(obj) + ' ' + obj.toString() + "\n");
					if (ads_app.onDebug) dumpProxy("<-- 1-Set to built-in native dry prototype function \n");
					finalValue = value; // keep dry
				}
				else{
					// if the value's associated membrane is the same as the membrane where obj is defined, 
					// then we should use the wet object here for value since they were defined 
					// from the same membrane, except value is a prototype object
					if (valueOrigin === calleeContext && !ads_app.nativePrototypeObjects.has(wetValue)){
						if (ads_app.onDebug) dumpProxy("<-- 2-Set to wet object \n");
						finalValue = wetValue;
					}
					else {//if they are different, then set dry value
						if (ads_app.onDebug) dumpProxy("<-- 3-Set to dry object \n");
						finalValue = value;							
					}
				}
			}						
			else {//value is a wet object

				//value's origin is from callerContext if it is unknown
				valueOrigin = ads_app.getObjOrigin(value);
				if (valueOrigin === "unknown"){
					valueOrigin = callerContext;
					ads_app.setObjOrigin(value, valueOrigin);
				}


				// if callee context and value origin are the same, then set wet.
				// this can be possible and legitimate, e.g. String.prototype.replace 
				// is used in host code, except value is a prototype object
				if (valueOrigin === calleeContext && !ads_app.nativePrototypeObjects.has(value)){  
					if (ads_app.onDebug) dumpProxy("<-- 4-Set wet object \n");
					return value;
				}					

				//if obj is one of built-in native prototype objects
				//then we always keep value dry 	
				if (ads_app.nativePrototypeObjects.has(obj)){
					//alert("--->This site writes to prototype object " + ads_app.isDry(obj) + ' ' + obj.toString() + "\n");
					ads_app.noContextCheckList.set(value,{});// for context switch validation
					if (ads_app.onDebug) dumpProxy("<-- 5-Set dry prototype fucntion\n");
					finalValue = ads_app.createProxy(value);
				}
				else{
					if (ads_app.onDebug) dumpProxy("<-- 6-Set dry obj\n");
					finalValue = ads_app.createProxy(value);
				}
			}						
		}
		return finalValue;
	},

	makeConstructor: function(obj, args) {
		//setup parameters
		var paras = "";
		for (var i = 0; i < args.length; i++) {
			paras = paras + "args[" + i + "],";
		}
		var code = "new obj(" + paras.slice(0, paras.length - 1) + ");";
		var eval = ads_app.originalEval;
		return function() {
			return eval(code);
		};
	},

	// this is a helper function to run a function with proper context switching
	runContextSwitch: function(f, callerContext, calleeContext, dbgmsg, transparent){
		var contextNum;
		var result;

		ads_app.enterContext(calleeContext, transparent);

		if (ads_app.contextDebugOn){
			contextNum = ads_app.contextNum++;

			dump(contextNum + " - Change context to " + calleeContext + " for " + dbgmsg + "\n");
			ads_app.printContextStack();
		}

		try {
			result = f();
		} finally {
			ads_app.exitContext(transparent);
			if (ads_app.contextDebugOn){
				dump(contextNum + " - Restore context to " + ads_app.currentContext + " after done " +  dbgmsg + "\n");
				ads_app.printContextStack();
			}
		}		
		return result;
	},

	//this function propagate node ownership 
	//starting from a node to all of its children
	propagateDomNodeOwner: function(aNode, owner, fromInnerHTML, initialNode){
		if (fromInnerHTML) {
			if (initialNode) {
				ads_app.domNodeOwner.set(aNode, owner);
				ads_app.markDomElm(aNode, "innerHTML", owner);
				ads_app.addActToLog(ads_app.opOrder++, {op:"INNERHTML", obj:aNode, initialNode:initialNode, caller:owner, callee:ads_app.hostDomain});
			} else
				initialNode = aNode;
		} else {
			ads_app.domNodeOwner.set(aNode, owner);
			ads_app.markDomElm(aNode, "domMethod", owner);			
		}
		if (aNode && aNode.hasChildNodes && aNode.hasChildNodes()) {
			var child = aNode.firstChild;
			while (child){
				ads_app.propagateDomNodeOwner(child, owner, fromInnerHTML, initialNode);
				child = child.nextSibling;
			}
		}
	},

	analyzeFun: function(arg, callerContext, calleeContext) {
		if ((callerContext === ads_app.hostDomain && callerContext!==calleeContext && calleeContext!=="jate_transparent") ||
			((callerContext +"tung" === ads_app.hostDomain) && ads_app.hostDomain!==calleeContext &&
			 callerContext!==calleeContext && calleeContext!=="jate_transparent")){							
			if (ads_app.isPrimitive(arg)){
				if (typeof arg === "string"){

					var div = arg !== "" ? document.getElementById(arg) : null;
					if (div && div.nodeName === "DIV" && !ads_app.domNodeOwner.get(div)){
						//visually mark it
						if (div.style) div.style.border = "8px solid red";
						div.title = div.title + ";(docwrite) assigned this div to " + ads_app.effectiveContext;
						ads_app.addDivToDomain(div,calleeContext,"host passes to ads (by calling an ads function) a string matching a div id " + arg);
					}
				}
			}
			else{
				var tempA = ads_app.getWet(arg);
				if (tempA.nodeName === "DIV" && !ads_app.domNodeOwner.get(tempA)){
					//dump("call " + calleeContext + " with a div element\n\n");
					ads_app.addDivToDomain(tempA,calleeContext,"host passes to ads (by calling an ads function) a div");
				}
			}
		}
	},


	// this is a helper function for apply trap that handle special built-in functions
	handleSpecialBuiltinFunction: function(obj, thisValue, args, callerContext, calleeContext, trap){
		var realWindow = ads_app.specialFunctionList.get(obj);
		var originalSpecialFunctions = ads_app.allWindows.get(realWindow);
		var result;
		var f;
		var dbgmsg;
		var i;
		var wArgs = [];
		
		
		// clearTimeout and clearInterval: need to pass thisValue as window
		if (obj === originalSpecialFunctions.clearTimeout || obj === originalSpecialFunctions.clearInterval) {
			for (i = 0; i < args.length; i++) {						
				args[i] = ads_app.processSetValue(args[i], obj, callerContext, calleeContext);
			}
			// TODO: if you want to policy addRemvoe, add a check here
			f = function(){
				return obj.apply(realWindow, args);
			};
			dbgmsg = " calling clearTimeout/clearInterval";					
			result = ads_app.runContextSwitch(f, callerContext, calleeContext, dbgmsg);												
			return result;
		}

		// setTimeout and setInterval can take a string argument as code, need to confine
		if (obj === originalSpecialFunctions.setTimeout || obj === originalSpecialFunctions.setInterval) {
			for (i = 0; i < args.length; i++) {						
				args[i] = ads_app.processSetValue(args[i], obj, callerContext, calleeContext);
			}

			if (typeof args[0] === "function") {
				//handle window.setTimeout(func, delay, [param1, param2, ...]);
				// we do not need to change context here because:
				// if thisValue is wet, then it is from host which we do not need to switch context 
				// if thisValue is dry, then the context will be handled by the apply trap
				f = function(){
					return obj.apply(realWindow, args);						
				};
				dbgmsg = " calling setTimeout/setInterval with function argument";					
				result = ads_app.runContextSwitch(f, callerContext, calleeContext, dbgmsg);												
				return result;							
			} 
			else { //handle window.setTimeout(aString, delay);								
				var func = function () {								
					realWindow.ads_app_confine = ads_app.confine; //to make sure that 'this' value is realWindow 
					realWindow.ads_app_confine(args[0], callerContext, realWindow, 0, 0);
				};								
				f = function(){
					return obj(func, args[1]);
				};
				dbgmsg = " calling setTimeout/setInterval with string argument";					
				result = ads_app.runContextSwitch(f, callerContext, calleeContext, dbgmsg);												
				return result;	
			}
		}

		// indirect call of eval, which is evaluated in the global scope 
		if (obj === originalSpecialFunctions.eval){
			var src;
			if (typeof args[0] === "string"){
				src = args[0];
			}
			else if (typeof args[1] === "string"){
				src = args[1];
			}
			else {
				alert("WEIRD EVAL, THIS SHOULD NEVER HAPPEN");
			}																				
			realWindow.ads_app_confine = ads_app.confineIndirectEval; //to make sure that 'this' value is realWindow 
			result = realWindow.ads_app_confine(src, callerContext, realWindow);
			return result;
		}


		// Function can take a string argument as code, need to confine
		// right now, we let it take arguments as they are						
		if (obj === originalSpecialFunctions.Function){
			var params = [].slice.call(args, 0);
			var body = params.pop();
			body = String(body || "");
			
			//ads_app.checkDOMXSS(body,'execution');
			
			var exprSrc;			 
			var scope = ads_app.createScope(callerContext, realWindow);													
			body = ads_rewriteThis(body);
			body = ads_rewriteEval(body);
			params = params.join(",");
			exprSrc = "function(" + params + "\n){" + body + "\n}";		
			exprSrc = "(function(){with(scope){return " + exprSrc + "}})();";
			if (exprSrc.indexOf('document.cookie')>=0){
				console.log("==>Construct dynamic code using built-in Function constructor");
				console.log("==>Dynamic code is rewritten:\n"+ exprSrc);
			}
			var eval = ads_app.originalEval; // can't use var eval = realWindow.eval; bug happens when realWindow!==top
			f = eval(exprSrc);
			return f;
		}


		// handle Array
		// Array.apply(athis, args) --> if call this way, elements in 
		// args will be converted to dry/wet automatically
		// Array(args) --> if call this way, args are already what (dry/wet)
		// they are supposed to be
		// --> So we can take arguments as they are 
		if (obj === originalSpecialFunctions.Array){		
			f = function(){
				return obj.apply(thisValue, args);
			};
			dbgmsg = " calling 'apply' of " + ads_app.objectToString.call(obj);					
			result = ads_app.runContextSwitch(f, callerContext, calleeContext, dbgmsg);			
			return result;							
		}		


		// handle document.write and document.writeln, has
		// to take wet this and processed arguments
		// store caller info for confinement later
		if (obj === originalSpecialFunctions.documentWrite || obj === originalSpecialFunctions.documentWriteln ||
			obj===ads_app.latestdocwrite || obj===ads_app.latestdocwriteln){
			for (i = 0; i < args.length; i++) {
				wArgs[i] = ads_app.getWetP(args[i]);
				if (!ads_app.isPrimitive(args[i])){
					args[i] = ads_app.processSetValue(args[i], obj, callerContext, calleeContext);								 
				}
			}

			if (!ads_app.isPrimitive(thisValue)){															
				thisValue = ads_app.getWet(thisValue);								
			}


			f = function(){
				return obj.apply(thisValue, args);
			};
			dbgmsg = " calling 'apply' of document.write";// + ads_app.functionToString.call(obj);
			ads_app.docWriteContext = ads_app.effectiveContext; // store context that calls document.write


			result = ads_app.runContextSwitch(f, callerContext, calleeContext, dbgmsg);
			ads_app.docWriteContext = ads_app.hostDomain; // restore document.write call context to host domain
			return ads_app.processGetValue(result, callerContext, calleeContext);
		}

		// handle Function.prototype.toString, has
		// to take wet arguments, including function-type ones
		if (obj === originalSpecialFunctions.functionToString){
			for (i = 0; i < args.length; i++) {						
				if (!ads_app.isPrimitive(args[i])){
					args[i] = ads_app.getWet(args[i]);									 
				}
			}							
			if (!ads_app.isPrimitive(thisValue)){															
				thisValue = ads_app.getWet(thisValue);
			}
			f = function(){
				return obj.apply(thisValue, args);
			};
			dbgmsg = " calling 'apply' of " + ads_app.functionToString.call(obj);					
			result = ads_app.runContextSwitch(f, callerContext, calleeContext, dbgmsg);
			return ads_app.processGetValue(result, callerContext, calleeContext);
		}

		// native constructors, should return a wet value. don't know about wetness of args
		// this list is getting longer and includes methods, maybe we should separate it
		if (obj === originalSpecialFunctions.Date || obj === originalSpecialFunctions.Object ||
			obj === originalSpecialFunctions.String || obj === originalSpecialFunctions.Number ||
			obj === originalSpecialFunctions.Boolean || obj === originalSpecialFunctions.RegExp ||
			obj === originalSpecialFunctions.Error || obj == originalSpecialFunctions.Uint32Array ||
			obj === originalSpecialFunctions.Promise || obj === originalSpecialFunctions.pResolve) {
			if (trap === "apply")
				return obj.apply(thisValue, args);
			else if (trap === "construct")
				// TODO: do these functions even belong in here? We should
				// have a separate special case to just make this code go
				// through the main construct path
				return ads_app.makeConstructor(obj, args)();
		}
	},




	// -This function creates a scope object for each untrusted code
	// this scope object simply says it has everything so that all
	// global property access will go through the scope object.
	// - When it sees a set operation (including variable declaration),
	// it will forward to the real proxy version of window
	// - When it sees a get operation, it will check first if 'window' has the property,
	// if not, throw a ReferenceError. Otherwise, forward the operation to proxy version of window
	//
	// ==> When running untrusted code directly under the object scope (using 'with'),
	// untrusted code can get to this scope object via 'this' value of a non-locally defined function  
	// and the function is invoked as a function like a()  (not a method like a.b()); 

	createScope: function (domain, realWindow) {
		if (!ads_app.scopeList){
			ads_app.scopeList = [];
		}
		for (var i=0; i<ads_app.scopeList.length; i++){
			var scopeInfo = ads_app.scopeList[i];
			if (scopeInfo.domain === domain && scopeInfo.window === realWindow){
				return scopeInfo.scope;
			}

		}
		ads_app.setObjOrigin(realWindow, ads_app.hostDomain);
		var twindow = ads_app.createProxy(realWindow);

		//function to process 'this'
		// 'this' value depends on where the function is defined
		// -if the function is defined right under the scope of scope object,
		// then 'this' is 'proxy'
		// -if the function is defined in a function scope, then 'this' is realWindow
		// ==> For both cases, we want to set 'this' to proxy of realWindow, which is twindow
		var ads_processThis = function(aThis){				
			return (aThis===proxy||aThis===realWindow)?twindow:aThis;
		};

		var proxy = new Proxy({}, {				
			has: function(target, n){
				return true;
			},
			set: function (target, n, value, receiver){
				twindow[n] = value;
			},
			get: function(target, n, receiver){		
				if (n==="ads_app"){//handle "Function"
					return ads_app;
				}
				if (n==="ads_processThis"){//handle 'this'
					return ads_processThis;
				}
				if (n==="realSecretScope"){//handle a special case of 'this'
					return proxy;
				}
				if (n==="realSecretWindow"){//handle a special case of 'this'
					return realWindow;
				}
				if (ads_app.directEval===1 && n==="eval"){ // handle eval
					// dump("######EVAL\n");
					ads_app.directEval = 0;
					return realWindow.eval;
				}
				if (ads_app.directEval===2 && n==="eval"){ // handle eval in ads_app.confine
					ads_app.directEval = 0;
					return realWindow.eval;
				}
				try{
					return twindow[n];
				}
				catch(e){
					console.log(e,n)
				}
			}
		});

		ads_app.scopeList.push({domain:domain, window:realWindow, scope:proxy});
		ads_app.mapD2W.set(proxy,realWindow);
		return proxy;
	},


	// each wet object will have one and only one corresponding dry object
	createProxy: function (obj) {			
		// already a proxy			
		if (ads_app.isDry(obj)){			
			return obj;
		}

		// if dry object for this obj was already created
		var dry= ads_app.getDry(obj);
		if (dry){
			return dry;
		}

		var objOrigin = ads_app.getObjOrigin(obj); // context (domain) where obj is created 
		if (objOrigin ==="unknown"){	
			var k = 1;
			alert("WEIRD, obj's origin should be known at this point " + obj);
		}

		var useWrapObj = true;

		try{
			// if obj is a window from an iframe
			if (obj.document && obj.document.defaultView){
				ads_app.setupBuiltInFunctions(obj);					
			}
			else if (obj.contentWindow && obj.contentDocument){ // if obj is an iframe object
				ads_app.setupBuiltInFunctions(obj.contentWindow);
			}
		}
		catch(e){
			// if there is a permission denied to document property, i.e. it is a 
			// window of an iframe that host does not have access to except postMessage				
			useWrapObj = false;				
		}

		var objectToWrap = obj;//shadow object used as the target object for an object
		if (useWrapObj){
			objectToWrap = {};//shadow object used as the target object for an object
			var objProto = obj.__proto__;

			// we always use the shadow object, just need to fix those default proxy features 
			// such as typeof, __proto__, toString, valueOf
			// we have to choose the type of shadow object according to the type of obj
			if (typeof obj === "object"){			    	
				objectToWrap.__proto__ = objProto?ads_app.getWet(objProto):objProto;					
			}

			else if (typeof obj === "function"){
				var args = "";
				for (var i=0; i<obj.length; i++) args = "a" + i + ",";
				if (i>0) args = args.slice(0,-1);
				try{
					eval("objectToWrap = function " + obj.name + "("+ args +"){};");
				}
				catch(e){
					objectToWrap = function(){};
				}				
				objectToWrap.prototype = obj.prototype;
				if (objectToWrap.prototype){
					objectToWrap.prototype = ads_app.getWet(objectToWrap.prototype);						
				}		
				objectToWrap.__proto__ = objProto?ads_app.getWet(objProto):objProto;				
			}
			else {
				//dump('!!! object is weird, typeof is weird ' + ads_app.objectToString.call(obj) + "\n");
			}




			// In fact , Proxy does not automatically forward these operations when used directly
			// like 'proxy.valueOf()', but it does automatically forward these operations when used implicitly (coercion)
			// like 'proxy == true', so we have to declare those opeations on shadow object
			var objDesc = ads_app.getOwnPropertyDescriptor(obj,"toString");
			if (!objDesc){
				objDesc = {enumerable:false};
			}

			ads_app.defineProperty(objectToWrap, "toString", {
				enumerable:objDesc.enumerable,
				configurable:true,
				writable:true,
				value: function(){
					//dump('call toString of ' + obj + "\n");
					return obj.toString();
				}
			});


			// have to define this because firefox Proxy will call valueOf of objectToWrap,
			// which trigger a lot of calls through objectToWrap.__proto__ which is a proxy.
			objDesc = ads_app.getOwnPropertyDescriptor(obj,"valueOf");
			if (!objDesc){
				objDesc = {enumerable:false};
			}

			ads_app.defineProperty(objectToWrap, "valueOf", {
				enumerable:objDesc.enumerable,
				configurable:true,
				writable:true,
				value: function(){		
					//dump('call value of ' + obj + "\n");
					return obj.valueOf();
				}
			});	


			// for enumeration because current Proxy has a bug which never triggers the enumeration trap 
			// objectToWrap.__iterator__ = function(){
			// 	for (var e in obj) yield e;
			// };
			// this alert is substituted by yield. uglify js does not support it
			objectToWrap.__iterator__ = function(){			
				var enumeratedPP = [];
				for (var p in obj) enumeratedPP.push(p);
				
				// enumerated property names will 
				// be a merge of enumerable property names of obj & enumerable
				// and own property names of shadow				
				for (var i=0; i<enumeratedPP.length; i++) yield enumeratedPP[i];
			};						
		}

		var proxy = new Proxy(objectToWrap, {
			
			// objects that need to be proxified:
			// window, window.document, window.location
			// window.history, window.history.pushState, window.history.replaceState
			// window.localStorage, window.localStorage.getItem, window.sessionStorage, 
			// window.sessionStorage.getItem
			get: function (target, n, receiver) {
				var result;					
				var callerContext = ads_app.currentContext;
				var calleeContext = objOrigin;					


				if (callerContext === calleeContext && !ads_app.noContextCheckList.has(obj) && !ads_app.firstContextIssue && proxy === receiver){
					ads_app.firstContextIssue = 1;
					try{
						throw new ads_app.originalError();
					} catch(e){
						if (ads_app.contextDebugOn) dump("Context and dry object have the same origins, get " +  n + " " +  obj +  " " + ads_app.currentContext + " " + e.stack+"\n");
					}
				}										

				// receiver inherits from proxy				
				// if property get is from a receiver, then caller context will be receiver's origin
				// if receiver's origin is unknown, it means that caller context must be the current 
				// context and receiver's origin is also the current context 
				if (proxy !== receiver){		
					if (ads_app.onDebug) dumpProxy("==> Receiver: GET '" + n + "' from object " + "\n");
					if (ads_app.isDry(receiver)){
						alert("RECEIVER IS DRY, WHICH SHOULD NOT HAPPEN");
					}
					var receiverOrigin = ads_app.getObjOrigin(receiver);
					if (receiverOrigin!=="unknown"){							
						callerContext = receiverOrigin;
					}
					else {
						ads_app.setObjOrigin(receiver, ads_app.currentContext);
					}
					if (n==="__proto__"){// this handles case x.__proto__ get where x.__proto__ === proxy					
						return proxy;
					}
				}	
				
				result = obj[n];
				result = ads_app.processGetValue(result, callerContext, calleeContext);				
				
				return result;
			},


			// when value is wet, then value is defined inside this current context
			//    --> then we have to wrap 'value' 
			// when value is dry, then it is defined from inside another membrane
			//    --> we have to check origin of value
			//			1. if the associated membrane is the same as the membrane where obj is defined, then 
			//				unwrap the dry object. We should use the wet object here for value.
			//			2. if they are different, then wrap value
			set: function (target, n, value, receiver) {
				var result;
				var callerContext = ads_app.currentContext;
				var calleeContext = objOrigin;	
				

				if (callerContext === calleeContext && !ads_app.noContextCheckList.has(obj) && !ads_app.firstContextIssue){
					ads_app.firstContextIssue = 1;
					try{
						throw new ads_app.originalError();
					} catch(e){
						if (ads_app.contextDebugOn) dump("Context and dry object have the same origins, set " + n + " of  " + ads_app.objectToString.call(obj) + " in context "  + ads_app.currentContext + " " + e.stack+"\n");
					}
				}
				if (proxy !== receiver){
					throw new ads_app.originalError("set trap triggered from receiver");
				}						


				// process 'value'
				var finalValue = ads_app.processSetValue(value, obj, callerContext, calleeContext);					
				var wFinalValue = ads_app.getWetP(finalValue);

				
				var f = function() {
					var w = obj.realSecretWindow;
					var ret;

					if (ads_app.adsDomPolicyEnforcementEnabled && w && obj instanceof w.Element){
						var policyEnforcementReturn = ads_app.nodeModificationByAdsPolicyEnforce(obj, {op:"SET", pn:n, obj:obj, val:wFinalValue, caller:ads_app.effectiveContext, callee: calleeContext});
						if (policyEnforcementReturn.shouldReturn){
							return policyEnforcementReturn.returnValue;
						}
					}


					// handle script text and innerHTML separately
					if (w && obj instanceof w.Element){						
						//we do this because getting tagName of 
						//HTMLImageElement.prototype raises an exception						
						var tagName;
						try{
							tagName = obj.tagName;
						}
						catch(e){}
						
						if (tagName === "SCRIPT" && (obj.type === "" || obj.type.contains("javascript")) 
							&& (n==="innerHTML"||n==="text"||n==="textContent")){
							return (obj[n] = ads_app.confine(finalValue, callerContext, obj.realSecretWindow, true));
						}					
					    else if (w && obj instanceof w.Element && n === "innerHTML" && !ads_app.disableDocWrite) {

						   ret = obj[n] = ads_docWrite(finalValue, callerContext, {innerHTML: true}, w, ads_app);

						   return ret;
					    } 					    
					}
					
					return (obj[n] = finalValue);
				};

				// right now, we run f without context switch
				// until handling prototype extension in context switch is done
				// which correctly handles getters/setters
				result = f();		


				//need to update objectToWrap for __proto__, prototype
				if ((n==="__proto__" || n==="prototype") && finalValue){
					objectToWrap[n] = ads_app.getWet(finalValue);
				}
				return result;
			},

			// should be handled like apply
			construct: function (target, args) {
				var result;	
				var callerContext = ads_app.currentContext;
				var calleeContext = objOrigin;
				
				if (callerContext === calleeContext && !ads_app.noContextCheckList.has(obj) && !ads_app.firstContextIssue){
					ads_app.firstContextIssue = 1;
					try{
						throw Error();
					} catch(e){
						if (ads_app.contextDebugOn) dump("Context and dry object have the same origins " + ads_app.currentContext + " " + e.stack+"\n");
					}
				}

				var wResult, wArgs = [];
				for (var i = 0; i < args.length; i++) {
					var v = args[i];
					wArgs.push(ads_app.getWetP(v));
				}

				// special functions that have custom wrappers and behaviors
				if (ads_app.specialFunctionList.has(obj)) {
					// policy check (if necessary is in the call)
					result = ads_app.handleSpecialBuiltinFunction(obj, null, args, callerContext, calleeContext, "construct");
					wResult = ads_app.getWetP(result);
					return result;
				}

				for (i = 0; i < args.length; i++) {						
					args[i] = ads_app.processSetValue(args[i], obj, callerContext, calleeContext);
				}


				var f = ads_app.makeConstructor(obj, args);
				result = ads_app.runContextSwitch(f, callerContext, calleeContext);

//				if (ads_app.nodeCreationMethodList.has(obj) && ads_app.effectiveContext !== ads_app.hostDomain)
//					ads_app.propagateDomNodeOwner(result, ads_app.effectiveContext); // set dom node's real owner. isNodeCreation results are always wet

				wResult = ads_app.getWetP(result);
				return ads_app.processGetValue(result, callerContext, calleeContext);
			},

			// call thisValue.obj(a1,a2,...,an);
			// should handle the same as we handle 'value' in 'set' trap for arguments and thisValue
			// result should be handled like get trap
			apply: function (target, thisValue, args) {					
				var result, wResult;	
				var callerContext = ads_app.currentContext;
				var calleeContext = objOrigin;				
				if (ads_app.onDebug) dumpProxy("##Call \"apply\" of " + ads_app.functionToString.call(obj) +  "\n");
				var f;
				
			

				// for checking inconsitency, maybe a bug
				if (callerContext === calleeContext && !ads_app.noContextCheckList.has(obj) && !ads_app.firstContextIssue){
					ads_app.firstContextIssue = 1;
					try{
						throw Error();
					} catch(e){
						if (ads_app.contextDebugOn) dump("Context and dry object have the same origins " + ads_app.functionToString.call(obj) + callerContext + " " + e.stack + "\n");
					}
				}

				if (ads_app.specialFunctionList.has(obj)) {
					// handle special built-in functions, don't need keepUID
					// policy checks (if necessary) are pushed into the following function
					result = ads_app.handleSpecialBuiltinFunction(obj, thisValue, args, callerContext, calleeContext, "apply");
					//wResult = ads_app.getWetP(result);
					//ads_app.addActToLog(ads_app.opOrder++, {op: "CALL", obj: obj, args: ads_app.array_map.call(args, ads_app.getWetP), thisValue: ads_app.getWetP(thisValue), result: ads_app.getWetP(result), caller: callerContext, callee: calleeContext});
					//ads_app.logPolicyApply(obj, thisValue, result);
					return result;
				}		

				
				// nodeCreation & nodeModifying: wetThis and processedArgs
				// nativef: prcessed function this and processed function args
				// wthisf: wet this and processed args (subset of native)
				// user: processed this and processed args
				var nodeCreation = ads_app.nodeCreationMethodList.has(obj);
				var nodeModification = ads_app.nodeModifyingMethodList.has(obj);
				var nativeF = ads_app.functionToString.call(obj).contains("[native code]") && !ads_app.userDefinedFuncs.has(obj);
				var wThisF = ads_app.wetThisProccessedArgumentList.has(obj);
				var user = !nativeF;

				// this code can be sped up by short-circuiting the assignments above
				for (var i = 0; i < args.length; i++) {
					if (user || nodeCreation || nodeModification || (nativeF && (wThisF || typeof args[i] === "function"))) {
						args[i] = ads_app.processSetValue(args[i], obj, callerContext, calleeContext);
					} 
					else
						args[i] = ads_app.getWetP(args[i]);
				}
				
				
				if (user || !wThisF)
					thisValue = ads_app.processSetValue(thisValue, obj, callerContext, calleeContext);
				else
					thisValue = ads_app.getWetP(thisValue);


				var keepUID = false;
				
				var w = obj.realSecretWindow;

				// confine scripts and track ownership for ads analysis
				if (nodeModification) {					
					if (obj === w.Element.prototype.appendChild ||
							obj === w.Element.prototype.insertBefore ||
							obj === w.Element.prototype.replaceChild){
						if (thisValue.tagName === "SCRIPT" && args[0].nodeType === Node.TEXT_NODE){// set content of a script tag through a text node
							args[0].textContent = ads_app.confine(args[0].textContent, callerContext, obj.realSecretWindow, 1);
						}						
					}
					// confine code in event handler
					// for example, aNode.setAttribute('onclick','alert(1);');
					else if (obj === w.Element.prototype.setAttribute){
						if (args[0][0]==='o' && args[0][1]==='n'){
							args[1] = ads_app.confine(args[1], callerContext, obj.realSecretWindow, 1);							
						}
					}
					else if (obj === w.Element.prototype.setAttributeNode){
						if (args[0].name[0] === 'o' && args[0].name[1] === 'n'){
							args[0].value = ads_app.confine(args[0].value, callerContext, obj.realSecretWindow, 1);							
						}
					}
				}

				// this function also does policy enforemcent
				// which might change the behavior of the function call				
				f = function(){					
					return obj.apply(thisValue, args);					
				};
				
				result = ads_app.runContextSwitch(f, callerContext, calleeContext, "", keepUID);
				
				var result = ads_app.processGetValue(result, callerContext, calleeContext);
				
				
								
				
				return result;
			},

			// Due to a bug from firefox, defineProperty is wrapped instead of proxified
			// so this trap is never triggered.
			// - Handle this trap like the set trap. If propertyDescriptor 
			// has 'getter' or 'setter', we treat it like 'value'. 
			// - Object.defineProperty does not trigger setter defined 
			// by Object.defineProperty or __defineSetter__, so no need 
			// to change currentContext
			defineProperty: function (target, n, propertyDescriptor) {
				if (ads_app.onDebug) dumpProxy("##Call defineProperty on " + n + " of " + ads_app.objectToString.call(obj) + "\n");					

				// propertyDescriptor is a dry object, then get the wet object
				// we can use wet propertyDescriptor because the only way to get 
				// descriptor is to use Object.getOwnPropertyDescriptor, and this
				// function return a new object every time it is called.
				if (ads_app.isDry(propertyDescriptor)){ 
					propertyDescriptor = ads_app.getWet(propertyDescriptor); 						
				}					

				//add to web log
				//ads_app.addActToLog(ads_app.opOrder++, {op:"defineProperty", pn:n, obj:obj, val:propertyDescriptor, debugVal:ads_app.debugVal}, ads_app.currentContext);


				// descriptor uses setter and getter
				if (propertyDescriptor.set || propertyDescriptor.get){
					propertyDescriptor.set = ads_app.processSetValue(propertyDescriptor.set, obj, ads_app.currentContext, objOrigin);
					propertyDescriptor.get = ads_app.processSetValue(propertyDescriptor.get, obj, ads_app.currentContext, objOrigin);
				}
				else {//descriptor uses 'value'
					propertyDescriptor.value = ads_app.processSetValue(propertyDescriptor.value, obj, ads_app.currentContext, objOrigin);
				} 

				// now define property
				ads_app.defineProperty(obj, n, propertyDescriptor);

				//need to update objectToWrap for __proto__, prototype, toString and valueOf
				if (objectToWrap!==obj){						
					if (n==="__proto__" || n=== "prototype" || n === "toString" || n ==="valueOf"){
						var objDesc = propertyDescriptor;
						if (objDesc.get || objDesc.set){
							ads_app.defineProperty(objectToWrap, n, {configurable:true, get:(objDesc.get?objDesc.get.bind(obj):undefined), set:(objDesc.set?objDesc.set.bind(obj):undefined), enumerable:objDesc.enumerable});
						}
						else{
							ads_app.defineProperty(objectToWrap, n, {configurable:true, writable:true, value:objDesc.value, enumerable:objDesc.enumerable});
						}
					}
				}

				// because Object.defineProperty(obj, n, propertyDescriptor) returns obj,
				// here we return the dry version of obj of the context
				return proxy;
			},

			// Handle this trap like get trap
			getOwnPropertyDescriptor: function (target, n) {
				if (ads_app.onDebug) dumpProxy("##Call getOwnPropertyDescriptor on " + n + " of " + ads_app.objectToString.call(obj) + "\n");

				// we have to sync shadow obj here to deal with proxy inheritance and non-enumerable property case 
				ads_app.syncShadow(objectToWrap, obj, n);
				
				

				var propertyDescriptor = ads_app.getOwnPropertyDescriptor(obj, n);
				if (propertyDescriptor){
					// descriptor uses setter and getter
					if (propertyDescriptor.set || propertyDescriptor.get){
						propertyDescriptor.set = ads_app.processGetValue(propertyDescriptor.set, ads_app.currentContext, objOrigin);
						propertyDescriptor.get = ads_app.processGetValue(propertyDescriptor.get, ads_app.currentContext, objOrigin);
					}
					else {//descriptor uses 'value'
						propertyDescriptor.value = ads_app.processGetValue(propertyDescriptor.value, ads_app.currentContext, objOrigin);
					}				
				}					
				return propertyDescriptor;
			},

			getOwnPropertyNames: function (target) {
				if (ads_app.onDebug) dumpProxy("##Call getOwnPropertyNames of " + ads_app.objectToString.call(obj) + "\n");
				
				var result = ads_app.getOwnPropertyNames(obj);
				
				
				
				return result;
			},

			keys: function (target) {
				if (ads_app.onDebug) dumpProxy("##Call keys of " + ads_app.objectToString.call(obj) + "\n");
				
				var result = ads_app.keys(obj);
				
				
				return result;
			},				

			deleteProperty: function (target, n) { // current firefox proxy makes an object non-configurable
				if (ads_app.onDebug) dumpProxy("##Call deleteProperty on " + n + " of " + ads_app.objectToString.call(obj) + "\n");
							
				var result = delete obj[n];
				
			
				if (result){ //if success, also delete it from the shadow object
					delete objectToWrap[n];
				}
				return result;
			},

			has: function (target, n) {					
				try{
					if (ads_app.onDebug) dumpProxy("##Call *has* '" + n + "' of " + ads_app.objectToString.call(obj) + "\n");
				}
				catch(e){
					if (ads_app.onDebug) dumpProxy("##Call \"has\" " + n + " of an object \n");
				}
				
				return (n in obj);				
			},

			hasOwn: function (target, n) {
				if (ads_app.onDebug) dumpProxy("##Call \"hasOwn\" on " + n + " of " + ads_app.objectToString.call(obj) + "\n");
				return ads_app.origObjProto_hasOwnProperty.call(obj, n);
			},	


			//fuck, this trap is never called, have to use __iterator__
			// actually we saw it called when testing this code:
			//var m ={};
			//m.__proto__ =prototypeTest;
			//var lll = m.a;
			//m.name = 4;
			//m.a = 4;
			enumerate: function (target) {
				if (ads_app.onDebug) dumpProxy("Call enumerate on " + ads_app.objectToString.call(obj) + "\n");
				//ads_app.syncShadow(objectToWrap, obj);
				var objArray = [];
				for (var e in obj){
					objArray.push(e);
				}
				return objArray;
			},

			iterate: function (target) {
				alert("##Call \"iterate\" of " + obj + "\n");					
				return new Iterator(obj);
			},


			preventExtensions: function (target) {
				if (ads_app.onDebug) dumpProxy("##Call \"preventExtensions\" of " + ads_app.objectToString.call(obj) + "\n");
				
				
				return ads_app.preventExtensions(obj);
			},

			seal: function (target) {
				if (ads_app.onDebug) dumpProxy("##Call \"seal\" of " + ads_app.objectToString.call(obj) + "\n");
				ads_app.seal(obj);
				ads_app.seal(objectToWrap);
				return proxy;
			},

			freeze: function (target) {
				if (ads_app.onDebug) dumpProxy("##Call \"freeze\" of " + ads_app.objectToString.call(obj) + "\n");
				return ads_app.freeze(obj);
			}
		});			


		ads_app.mapW2D.set(obj, proxy);
		ads_app.mapD2W.set(proxy, obj);				

		if (ads_app.onDebug) dumpProxy("<<<>>>> CREATE A PROXY FOR: " + ads_app.objectToString.call(obj) + " in " + objOrigin + " context:" + ads_app.currentContext + "\n");			
		return proxy;
	},		

	//main confine function for dynamic code
	confine:function (src, domain, window, noEval) {
		//ads_app.checkDOMXSS(src, "execution");
		ads_app.setupBuiltInFunctions(window);		
		src = ads_confine(src, domain);

		if (noEval){ // only rewrite source
			return src;
		}

		var eval = window.eval;
		return eval(src);
	},

	//function to confine indirect eval, which handles return value
	confineIndirectEval:function (src, domain, window, noEval){
		// check if src is already rewritten
		if (src.indexOf('ads_app')>=0)
			return src;
		
		ads_app.setupBuiltInFunctions(window);
		src = ads_rewriteFunction(src);
		src = ads_rewriteEval(src);
		src = ads_rewriteThis(src);	
		ads_app.evalSrc = src;
		src = 	"if (!window.ads_app){window.ads_app=top.ads_app;}\n" +
		"ads_app.scope = ads_app.createScope('"+domain+"',window);\n" +	
		"try{\n" +
		"	with (ads_app.scope){\n" +
		(noEval?(src+ "\n"):"		ads_app.returnEval = (ads_app.directEval=2, eval(ads_app.evalSrc));\n") +
		"	}\n" +					
		"}\n" +
		"catch(e){\n" +
		"	throw e;\n" +
		"}\n";


		if (noEval){ // only rewrite source
			return src;
		}

		var eval  = window.eval;
		eval(src);
		return ads_app.returnEval;
	},

	// the white-list also contain 'eval' because it is special and already handled by code rewriting
	// 'w': window object of a frame, we have to do this for each window frame having the same origin as the host
	// What are built-in functions that can be accessed implicitly without going through proxy?
	// + Array prototype functions (([]).concat)
	// + Object prototype functions (({}).valueOf), many of them already handled by Proxy
	// + In fact, all prototype functions? YES. These functions can be accessed implicitly through a wet variable
	// and won't go through proxy
	//
	// The only reason we have to wrap built-in functions is to preserve identity, i.e. semantics in normal JavaScript. 
	// Let's say untrusted code can get direct accesses to these built-in functions, 
	// by crazy ways like (function (){}).__proto__.constructor), 
	// which are already frozen, so they might break their code semantics, 
	// but can not bypass security. This is fail-safe. 
	// With this enforcement decision, we can choose certain common built-in functions to wrap at the start-up. The 
	// bug that we reported on V8 does not work on Firefox, so we basically do not have to wrap all Array prototype functions.
	//
	// Origins of all prototype non-whitelist functions should be setn here because they can be accessed implicitly and 
	// their origins might be set incorrectly later
	setupBuiltInFunctions: function(w, url){		
		if (w.realSecretWindow){
			return;
		}

		// set ads_app
		w.ads_app = ads_app;

		// add info to object prototype to indicate that this 'w' is already processed 
		w.Object.defineProperty(w.Object.prototype,"realSecretWindow", {value:w, enumerable:false, configurable:false, writable:false});		
		
		
		// this list contains all functions that won't be wrapped
		// in both host domain and untrusted domains
		if (!ads_app.whiteList){
			ads_app.whiteList = new WeakMap();
		}

		// this list contains all wet native prototype objects
		if (!ads_app.nativePrototypeObjects){
			ads_app.nativePrototypeObjects = new WeakMap();
		}

		// this list contains functions that
		// we do not check for context integrity 
		// when their dry ones are used
		if (!ads_app.noContextCheckList){
			ads_app.noContextCheckList = new WeakMap();
		}

		// this list contains user-defined functions
		// that are bound by Function.prototype.bind
		if (!ads_app.userDefinedFuncs){
			ads_app.userDefinedFuncs = new WeakMap();
		}

		// this list contains document.all from windows
		// to solve the bug that proxy does not work
		// correctly with document.all. The test 
		// if (document.all){} always return true for
		// dry document.all
		if (!ads_app.documentAll){
			ads_app.documentAll = new WeakMap();
		}
		ads_app.documentAll.set(w.document.all,{});



		// this list contains all DOM methods that
		// generate new node, which are used to keep
		// track of a node's real owner.
		if (!ads_app.nodeCreationMethodList){
			ads_app.nodeCreationMethodList = new WeakMap();
		}			
		[w.document.createAttribute, w.document.createComment, w.document.createDocumentFragment,
		 w.document.createElement, w.document.createElementNS, w.document.createTextNode, w.Element.prototype.cloneNode, w.Image].forEach(function(f){
			 ads_app.nodeCreationMethodList.set(f,w);
		 });


		// this list contains all DOM methods that
		// modify a DOM node
		if (!ads_app.nodeModifyingMethodList){
			ads_app.nodeModifyingMethodList = new WeakMap();
		}			
		[w.document.importNode, w.document.normalize, 
		 w.Element.prototype.appendChild, w.Element.prototype.insertBefore, w.Element.prototype.removeChild,
		 w.Element.prototype.replaceChild, w.Element.prototype.removeAttribute, w.Element.prototype.removeAttributeNode, 
		 w.Element.prototype.normalize, w.Element.prototype.setAttribute, w.Element.prototype.setAttributeNode].forEach(function(f){
			 ads_app.nodeModifyingMethodList.set(f,w);
		 });

		// this list contains functions that we need 
		// to handle differently when their dry ones are used
		if (!ads_app.specialFunctionList){
			ads_app.specialFunctionList = new WeakMap();
		} 

		// functions that need special cares
		var originalSpecialFunctions = {	
				clearInterval:w.clearInterval,	
				clearTimeout:w.clearTimeout,
				setTimeout: w.setTimeout,
				setInterval: w.setInterval,
				eval: w.eval,
				Function: w.Function,
				Array: w.Array,
				Object: w.Object,
				String: w.String, 
				Number: w.Number, 
				Boolean: w.Boolean,
				RegExp: w.RegExp,
				Date: w.Date,
				Error: w.Error,
				Uint32Array: w.Uint32Array,
				Promise: w.Promise,
				pResolve: w.Promise.resolve,
				functionToString: w.Function.prototype.toString,				
		};

		Object.keys(originalSpecialFunctions).forEach(function(k) {
			ads_app.specialFunctionList.set(originalSpecialFunctions[k], w);
		});

		ads_app.specialFunctionList.set(w, w.Array.prototype); // TODO: what???

		//this list contains references to original special functions
		//so that even if these functions are overwritten, we can still
		//have access to original ones, which are used in proxy traps
		if (!ads_app.allWindows){
			ads_app.allWindows = new WeakMap();
		}
		ads_app.allWindows.set(w, originalSpecialFunctions);



		//this list contains all built-in functions
		//that take in non-object arguments. For these
		//functions, we have to origin-proccess arguments
		//in apply trap rather than passing wet arguments
		//because if an object is passed as an argument,
		//the object's valueOf or toString is implicitly 
		//triggered, then context is not correctly switched. 
		//These functions can not be whitelisted because they 
		//needs to take wet thisValue (for example, w.Performance.prototype.now)
	
		if (!ads_app.wetThisProccessedArgumentList){
			ads_app.wetThisProccessedArgumentList = new WeakMap();
		}			
		[w.XMLHttpRequest.prototype.open, w.XMLHttpRequest.prototype.send, 
		 w.Element.prototype.setAttribute, w.Element.prototype.getAttribute, w.Element.prototype.getAttributeNode, 
		 w.Element.prototype.getElementsByTagName, w.Element.prototype.hasAttribute, w.Element.prototype.isDefaultNamespace,
		 w.MozNamedAttrMap.prototype.getNamedItem, w.MozNamedAttrMap.prototype.item, w.MozNamedAttrMap.prototype.removeNamedItem,
		 w.document.createComment, w.document.createTextNode, w.document.getElementById,
		 w.document.getElementsByName, w.document.getElementsByTagName, 
		 w.RegExp.prototype.test, w.RegExp.prototype.exec, w.Performance.prototype.now].forEach(function(f){
			 ads_app.wetThisProccessedArgumentList.set(f,w);
		 });



		//this list contains all non-whitelisted built-in functions 
		//that have to take 'this' and arguments as they are
		if (!ads_app.nonProcessedThisNonProcessedArgumentList){
			ads_app.nonProcessedThisNonProcessedArgumentList = new WeakMap();
		}
		[w.eval, w.Array].forEach(function(f){
			ads_app.nonProcessedThisNonProcessedArgumentList.set(f,w);
		});



		//this list contains all built-in functions that have to
		//take wet 'this' and wet arguments
		if (!ads_app.wetThisWetArgumentList){
			ads_app.wetThisWetArgumentList = new WeakMap();
		}
		[w.Function.prototype.toString].forEach(function(f){
			ads_app.wetThisWetArgumentList.set(f,w);
		});


		//this list contains all built-in functions that have to
		//take processed 'this' and processed arguments
		if (!ads_app.processedThisProcessedArgumentList){
			ads_app.processedThisProcessedArgumentList = new WeakMap();
		}
		[w.setTimeout, w.setInterval].forEach(function(f){
			ads_app.processedThisProcessedArgumentList.set(f,w);
		});				



		// helper function for JSON.stringify wrapper
		// this function will convert obj to wet including
		// all its properties recursively
		var getWetWholeObject = function(obj){
			var newObj;
			if (ads_app.isDry(obj)){
				obj = ads_app.getWet(obj);
			}
			if (ads_app.isArray(obj)){//if obj is an array
				newObj = [];
				for (var i=0;i<obj.length;i++){
					newObj[i] = obj[i];
					if (!ads_app.isPrimitive(obj[i])){								
						newObj[i] = getWetWholeObject(obj[i]);
					}						
				}
			}
			else if (typeof obj === "object"){ // object
				newObj = {};
				for (var prop in obj){
					if(ads_app.origObjProto_hasOwnProperty.call(obj,prop)) {// only own properties
						newObj[prop] = obj[prop];
						if (!ads_app.isPrimitive(obj[prop])){								
							newObj[prop] = getWetWholeObject(obj[prop]);
						}
					}						
				}
			}
			else {// function
				newObj = obj;
			}
			return newObj;
		};

		// we need to wrap JSON.stringify because
		// it does not work correctly with dry objects
		// especially when a dry object is an array in 
		// wet version
		var originalJSONStringigy = w.JSON.stringify;
		w.JSON.stringify = function stringify(obj){
			if (!ads_app.isPrimitive(obj)){
				obj = getWetWholeObject(obj);
			}
			return originalJSONStringigy(obj);
		};




		//Wrap __proto__ getter so that even host can only get to wrapped native
		//prototype objects.
		var protoD = w.Object.getOwnPropertyDescriptor(w.Object.prototype, "__proto__");
		var getter = protoD.get;			
		var setter = protoD.set;
		var protoDesc = {};
		var protoGetter = function(){
			var proto = getter.call(this);
			if (proto && ads_app.nativePrototypeObjects.has(proto)){
				proto = ads_app.createProxy(proto);
			}								
			return proto;				
		};			
		protoDesc.get = protoGetter;
		protoDesc.set = setter;
		protoDesc.configurable = false;
		protoDesc.enumerable = false;
		w.Object.defineProperty(w.Object.prototype, "__proto__", protoDesc);
		
		
		//Wrap Object.prototype.toString
		//Reason: Object.prototype.toString.call(proxy) unconditionally 
		//returns Object.prototype.toString.call(target)
		var originalObjProtoToString = w.Object.prototype.toString;
		w.Object.prototype.toString = function toString(){
			var wetThis = this;
			if (ads_app.isDry(this)){
				wetThis = ads_app.getWet(this);
			}
			return originalObjProtoToString.call(wetThis);
		};
		
	

		//Built-in Array functions does not work with dry objects
		//even host needs to use a wrapped version
		var object = w.Array;			
		["isArray"].forEach(function(name) {
			// reuse desc to avoid reiterating prop attributes
			var desc = ads_app.getOwnPropertyDescriptor(object, name);
			var existingMethod = desc.value;		      
			if (typeof existingMethod === "function" && !ads_app.mapD2W.has(existingMethod)){ 
				ads_app.noContextCheckList.set(existingMethod,{});
				ads_app.setObjOrigin(existingMethod, ads_app.hostDomain);
				desc.value = ads_app.createProxy(existingMethod);
				w.Object.defineProperty(object, name, desc);
				ads_app.whiteList.set(object[name],{});
			}      
		});


		//Wrap String.prototype.split
		//Reason: String.prototype.split does not work well with  
		//dry objects
		var originalStringProtoSplit = w.String.prototype.split;
		w.String.prototype.split = function split(){
			var wetThis = this;
			if (ads_app.isDry(this)){
				wetThis = ads_app.getWet(this);
			}
			return originalStringProtoSplit.apply(wetThis, arguments);
		};
		
		
		//Built-in String prototype functions can be accessed implicitly ('a'.replace)
		//and won't work with dry objects
		object = w.String.prototype;
		// these functions can take a regular expression object as argument
		// and won't work if the regular expression is a dry object
		["replace", "search"].forEach(function(name) {
			// reuse desc to avoid reiterating prop attributes
			var desc = ads_app.getOwnPropertyDescriptor(object, name);
			var existingMethod = desc.value;		      
			if (typeof existingMethod === "function" && !ads_app.mapD2W.has(existingMethod)){
				ads_app.noContextCheckList.set(existingMethod,{});
				ads_app.setObjOrigin(existingMethod, ads_app.hostDomain);
				desc.value = ads_app.createProxy(existingMethod);
				w.Object.defineProperty(object, name, desc);
				ads_app.whiteList.set(object[name],{});
			}      
		});			

		//Wrap String.prototype.match
		//Reason: String.prototype.match should return a dry array if the regex is dry
		var originalStringProtoMatch = w.String.prototype.match;
		w.String.prototype.match = function match(regex){
			var wThis = ads_app.getWetP(this);
			var wRegex = ads_app.getWetP(regex);
			var result = originalStringProtoMatch.call(wThis, wRegex);
			if (wRegex !== regex)
				return ads_app.processGetValue(result, ads_app.currentContext, ads_app.hostDomain);
			else
				return result;
		};


		//Built-in Function prototype functions can be accessed implicitly (a.toString)
		//and won't work with dry objects			
		object = w.Function.prototype;			
		["toString"].forEach(function(name) {
			// reuse desc to avoid reiterating prop attributes
			var desc = ads_app.getOwnPropertyDescriptor(object, name);
			var existingMethod = desc.value;		      
			if (typeof existingMethod === "function" && !ads_app.mapD2W.has(existingMethod)){ 
				ads_app.noContextCheckList.set(existingMethod,{});
				ads_app.setObjOrigin(existingMethod, ads_app.hostDomain);
				desc.value = ads_app.createProxy(existingMethod);
				w.Object.defineProperty(object, name, desc);
				ads_app.whiteList.set(object[name],{});
			}      
		});

		// fix Object.prototype.isPrototypeOf
		// because of following reasons:
		// a) isPrototypeOf does not work correctly with dry object
		// b) prototype chain can contain wet and dry objects
		w.Object.prototype.isPrototypeOf = function(obj){
			var currentNode = obj;
			var aThis = this;
			if (ads_app.isDry(this)){
				aThis = ads_app.getWet(this);
			}
			while (currentNode){
				if (ads_app.isDry(currentNode)){
					currentNode = ads_app.getWet(currentNode);
				}
				if (currentNode === aThis){
					return true;
				}
				currentNode = currentNode.__proto__;
			}
			return false;
		};

		//Fix Object.seal because Proxy 'seal' trap throws error 
		//"proxy can't report an extensible object as non-extensible"
		//when using with Proxy which uses shadow object
		ads_app.setObjOrigin(w.Object.seal,ads_app.hostDomain);
		ads_app.noContextCheckList.set(w.Object.seal,{});
		w.Object.seal = ads_app.createProxy(w.Object.seal);

		//As a result of fixing Object.seal, we also have to fix Object.isSealed
		ads_app.setObjOrigin(w.Object.isSealed,ads_app.hostDomain);
		ads_app.noContextCheckList.set(w.Object.isSealed,{});
		w.Object.isSealed = ads_app.createProxy(w.Object.isSealed);


		// -Any built-in function that has to take wet arguments (or won't work)
		// and return an object that contain properties of arguments will need to be fixed
		// - fixed Array.prototype.concat:
		// return an array that contain elements from 'this' and arguments. 
		// Only need to handle argument that is an array and dry.
		var originalArrayConcat = w.Array.prototype.concat; 
		w.Array.prototype.concat = function(){
			var args = arguments;				
			var finalArgs = [];
			var i,j;
			for (i = 0; i < args.length; i++) {
				finalArgs[i] = args[i];
				if (!ads_app.isPrimitive(args[i])){	
					var wetArg = ads_app.getWet(args[i]);						
					if (wetArg!==args[i] && ads_app.objectToString.call(wetArg) === "[object Array]"){ // argument is an array and dry						
						var argOrigin = ads_app.getObjOrigin(wetArg);
						finalArgs[i] = [];
						for (j=0; j<wetArg.length;j++){
							finalArgs[i][j] = ads_app.processGetValue(wetArg[j], ads_app.currentContext, argOrigin);
						}
					}
				}
			}

			var finalThis = this;
			if (!ads_app.isPrimitive(this)){								
				var wetThis = ads_app.getWet(this);
				if (wetThis!==this && ads_app.objectToString.call(wetThis) === "[object Array]"){ // 'this' is an array and dry						
					var thisOrigin = ads_app.getObjOrigin(wetThis);
					finalThis = [];
					for (j=0; j<wetThis.length;j++){
						finalThis[j] = ads_app.processGetValue(wetThis[j], ads_app.currentContext, thisOrigin);
					}												
				}
			}

			return originalArrayConcat.apply(finalThis, finalArgs);
		};


		// fix Object.getPrototypeOf
		// Object.getPrototypeOf does not work correctly for Proxy. This code does not work correctly
		// o = {};
		// o["__proto__"] = {f:1};
		// m = new Proxy(o,{});
		// o["__proto__"] = {f:2};
		// Object.getPrototypeOf(m);
		// This code returns old proto instead of new proto, which is incorrect
		w.Object.getPrototypeOf = function(obj){
			return obj.__proto__;				
		};		


		var originalObjectDefineProperty = w.Object.defineProperty;
		//fix Object.defineProperty for Proxy bug 'proxy can't define a non-existent property as non-configurable'
		w.Object.defineProperty = function defineProperty(obj, n, propertyDescriptor) {
			if (ads_app.onDebug) dumpProxy("##Call defineProperty on " + n + " of " + ads_app.objectToString.call(obj) + "\n");				

			var result = obj;
			if (ads_app.isDry(obj)){
				obj = ads_app.getWet(obj);
			}				
			

			var objOrigin = ads_app.getObjOrigin(obj);
			if (objOrigin === "unknown"){
				objOrigin = ads_app.currentContext;
			}
			
			
		
			

			var pdesc = {};

			for (var p in propertyDescriptor){
				if (propertyDescriptor.hasOwnProperty(p))
					pdesc[p] = ads_app.processSetValue(propertyDescriptor[p], obj, ads_app.currentContext, objOrigin);
			}

			//add to web log
			//ads_app.addActToLog(ads_app.opOrder++, {op:"defineProperty", pn:n, obj:obj, val:pdesc, debugVal:ads_app.debugVal}, ads_app.currentContext);

			// now define property
			originalObjectDefineProperty(obj, n, pdesc);

			//need to update objectToWrap for __proto__, prototype
			//but we are not doing it now because using defineProperty for
			//these properties is not common


			// because Object.defineProperty(obj, n, propertyDescriptor) returns obj,
			// here we return the version of obj of the context
			return result;
		};

		var originalObject = w.Object;
		//also need to fix Object.defineProperties
		w.Object.defineProperties = function defineProperties(){
			var obj = arguments[0];
			var pds = arguments[1];
			if (ads_app.isDry(pds)){
				pds = ads_app.getWet(pds);
			}	
			for (var k in pds){
				if (pds.hasOwnProperty(k))
					originalObject.defineProperty(obj, k, pds[k]);
			}
			return obj;
		};			


		//fix Function.prototype.bind
		//when a user-defined function is bound like a = f.bind(null,...), 
		//then a.toString() is "function () { [native code] }", which we 
		//incorrectly treat it like a native function. 
		//We need to fix this by wrapping Function.prototype.bind 
		var originalFunctionBind = w.Function.prototype.bind;
		w.Function.prototype.bind = function(){
			var wetThis = ads_app.getWet(this);
			var result = originalFunctionBind.apply(this, arguments);
			if (ads_app.userDefinedFuncs.has(wetThis) ||
					ads_app.functionToString.call(wetThis).indexOf("[native code]") < 0){
				ads_app.userDefinedFuncs.set(ads_app.getWet(result),{});
			}
			return result;
		};




		// Wrap Blob to correctly handle arguments
		var originalBlob = w.Blob;
		w.Blob = function(){
			var args = arguments;
			for (var i = 0; i < args.length; i++) {
				if (!ads_app.isPrimitive(args[i]))
					args[i] = ads_app.getWet(args[i]);
			}
			return ads_app.makeConstructor(originalBlob, args)();
		};
		w.Blob.prototype = originalBlob.prototype; 
		originalBlob.prototype.constructor = w.Blob;

		// means whitelisted functions, always wet
		var t = true;

		// means that when run inside untrusted code, it is dry
		// and run in host code, it is wet
		// ==> any built-in function taking object-type argument
		var f = false; 

		
		//we adapt this whitelist from SES
		var whitelist =  {
				window:{
					escape: t, // ES5 Appendix B
					unescape: t, // ES5 Appendix B
					NaN: t,
					Infinity: t,
					parseInt: t,
					parseFloat: t,
					isNaN: t,
					isFinite: t,
					decodeURI: t,
					decodeURIComponent: t,
					encodeURI: t,
					encodeURIComponent: t,						
					console: t,
					//performance: t, // does this facilitate timing attacks?, disabled because there is a bug in FF31 when accessing this from an iframe
				},
				WeakMap: { // ES-Harmony proposal as currently implemented by FF6.0a1
					prototype: {							
						//'delete': t
					}
				},			
				Object: {						
					getPropertyDescriptor: t, // ES-Harmony proposal
					getPropertyNames: t, // ES-Harmony proposal
					is: t, // ES-Harmony proposal
					prototype: {							
						__defineGetter__: f,
						__defineSetter__: f,
						__lookupGetter__: f,
						__lookupSetter__: f,

						toString: t, 
						valueOf: f,
						hasOwnProperty: t,
						isPrototypeOf: t,
						propertyIsEnumerable: t
					},						
					getPrototypeOf: t,
					getOwnPropertyDescriptor: t,
					getOwnPropertyNames: t,
					create: t,
					defineProperty: t,
					defineProperties: t,
					seal: t,
					freeze: f,
					preventExtensions: f,
					isSealed: t,
					isFrozen: f,
					isExtensible: f,
					keys: t
				},

				Array: {
					prototype: {
						concat: t,
						join: t,
						pop: t,
						push: t,
						reverse: t,
						shift: t,
						slice: t,
						sort: t,
						splice: t,
						unshift: t,
						indexOf: t,
						lastIndexOf: t,
						every: t,
						some: t,
						forEach: t,
						map: t,
						filter: t,
						reduce: t,
						reduceRight: t,
						length: t
					},
					isArray:t
				},
				Blob: {
					prototype: {						
						slice: t						
					}					
				},
				String: {
					prototype: { // these String prototype functions when called on dry object, toString() is implicitly called on the dry object, which is already handled.
						substr: t, // ES5 Appendix B
						anchor: t, // Harmless whatwg
						big: t, // Harmless whatwg
						blink: t, // Harmless whatwg
						bold: t, // Harmless whatwg
						fixed: t, // Harmless whatwg
						fontcolor: t, // Harmless whatwg
						fontsize: t, // Harmless whatwg
						italics: t, // Harmless whatwg
						link: t, // Harmless whatwg
						small: t, // Harmless whatwg
						strike: t, // Harmless whatwg
						sub: t, // Harmless whatwg
						sup: t, // Harmless whatwg
						trimLeft: t, // non-standard
						trimRight: t, // non-standard
						valueOf: f,
						charAt: t,
						charCodeAt: t,
						concat: t,
						indexOf: t,
						lastIndexOf: t,
						localeCompare: t,
						match: t,
						replace: t,
						search: t,
						slice: t,
						split: t,
						substring: t,
						startsWith: t,
						endsWith: t,
						toLowerCase: t,
						toLocaleLowerCase: t,
						toUpperCase: t,
						toLocaleUpperCase: t,
						trim: t,
						length: "*"
					},
					fromCharCode: t
				},
				Boolean: {
					prototype: { // these function prototype when called on dry object does not automatically call valueOf or toString of dry object
						valueOf: f
					}
				},
				Number: {
					prototype: {
						valueOf: f,
						toFixed: f,
						toExponential: f,
						toPrecision: f
					},
					MAX_VALUE: t,
					MIN_VALUE: t,
					NaN: t,
					NEGATIVE_INFINITY: t,
					POSITIVE_INFINITY: t
				},
				Math: {
					E: t,
					LN10: t,
					LN2: t,
					LOG2E: t,
					LOG10E: t,
					PI: t,
					SQRT1_2: t,
					SQRT2: t,

					abs: t,
					acos: t,
					asin: t,
					atan: t,
					atan2: t,
					ceil: t,
					cos: t,
					exp: t,
					floor: t,
					log: t,
					max: t,
					min: t,
					pow: t,
					random: t, // questionable
					round: t,
					sin: t,
					sqrt: t,
					tan: t
				},
				Date: { // no-arg Date constructor is questionable
					prototype: {
						// Note: coordinate this list with maintanence of repairES5.js
						getYear: f, // ES5 Appendix B
						setYear: f, // ES5 Appendix B
						toGMTString: f, // ES5 Appendix B2dsd
						toDateString: f,
						toTimeString: f,
						toLocaleString: f,
						toLocaleDateString: f,
						toLocaleTimeString: f,
						valueOf: f,
						getTime: f,
						getFullYear: f,
						getUTCFullYear: f,
						getMonth: f,
						getUTCMonth: f,
						getDate: f,
						getUTCDate: f,
						getDay: f,
						getUTCDay: f,
						getHours: f,
						getUTCHours: f,
						getMinutes: f,
						getUTCMinutes: f,
						getSeconds: f,
						getUTCSeconds: f,
						getMilliseconds: f,
						getUTCMilliseconds: f,
						getTimezoneOffset: f,
						setTime: f,
						setFullYear: f,
						setUTCFullYear: f,
						setMonth: f,
						setUTCMonth: f,
						setDate: f,
						setUTCDate: f,
						setHours: f,
						setUTCHours: f,
						setMinutes: f,
						setUTCMinutes: f,
						setSeconds: f,
						setUTCSeconds: f,
						setMilliseconds: f,
						setUTCMilliseconds: f,
						toUTCString: f,
						toISOString: f,
						toJSON: f
					},
					parse: t,
					UTC: t,
					now: f
				},
				RegExp: {
					prototype: {
						exec: f,
						test: f,
						source: t,
						global: t,
						ignoreCase: t,
						multiline: t,
						lastIndex: t,
						options: t, // non-std
						sticky: t // non-std
					}
				},
				Error: {
					prototype: {
						name: t,
						message: t
					}
				},
				EvalError: {
					prototype: t
				},
				RangeError: {
					prototype: t
				},
				ReferenceError: {
					prototype: t
				},
				SyntaxError: {
					prototype: t
				},
				TypeError: {
					prototype: t
				},
				URIError: {
					prototype: t
				},
				JSON: {
					parse: t,
					stringify: t
				},				
				Function:{
					prototype:{
						toString:t,
						call:t,
						apply:t,
						bind:t
					}
				}					
		};


		//We whitelist only built-in prototype functions and some built-in functions from 'window'
		var whiteObj;	
		ads_app.keys(whitelist).forEach(function(e1){				
			whiteObj = eval("w."+e1);
			if (!ads_app.isPrimitive(whiteObj) && !ads_app.isDry(whiteObj)){
				ads_app.setObjOrigin(whiteObj,ads_app.hostDomain);
			}				
			if (typeof whitelist[e1] === "object"){
				ads_app.keys(whitelist[e1]).forEach(function(e2){
					try{
						whiteObj = eval("w."+e1+"."+e2);
					}
					catch(e){
						alert(e+ " " + e1+ " " + e2);
					}
					if (!ads_app.isPrimitive(whiteObj) && !ads_app.isDry(whiteObj)){
						ads_app.setObjOrigin(whiteObj,ads_app.hostDomain);
					}
					if (e2!=="prototype") {
						if (whitelist[e1][e2]){								
							try{ads_app.whiteList.set(whiteObj,{});}catch(ee){}
						}							
					}						
					if (typeof whitelist[e1][e2]==="object"){
						ads_app.keys(whitelist[e1][e2]).forEach(function(e3){								
							whiteObj = eval("w."+e1+"."+e2+"."+e3);
							if (!ads_app.isPrimitive(whiteObj) && !ads_app.isDry(whiteObj)){
								ads_app.setObjOrigin(whiteObj,ads_app.hostDomain);
							}
							if (whitelist[e1][e2][e3]){									
								try{ads_app.whiteList.set(whiteObj,{});}catch(ee){}
							}
							else{ // prototype non-whitelisted functions
								ads_app.noContextCheckList.set(whiteObj,{});									
							}
						});
					}
				});
			}			
		});			


		// Proxify native constructors
		// we have to wrap them using proxy instead because
		// we both want prototype object to be wrapped and
		// 'instanceof' to work
		["Function", "Object", "Array", "String", "Number", "Boolean","RegExp","Error"].forEach(function(e){				
			var originalObject = w[e];
			//ads_app.noContextCheckList.set(originalObject,{});					
			//ads_app.noContextCheckList.set(originalObject.prototype,{});
			w[e] = ads_app.createProxy(originalObject);
			if (!ads_app.isDry(originalObject.prototype.constructor)){				
				originalObject.prototype.constructor = w[e];
			}			
			ads_app.nativePrototypeObjects.set(originalObject.prototype,{});
			ads_app.whiteList.set(w[e],{});
		});			



		// wrap document.open and document.write because it causes window's properties to be refreshed
		// (except document). After these functions are called, we might need to run setupBuiltInFunctions again
		if (!w.document.isOpenAlreadyWrapped){
			ads_app.defineProperty(w.document,"isOpenAlreadyWrapped", {value:1, enumerable:false, configurable:false});
			var documentPrototype = ads_app.getPrototypeOf(w.document);

			var originalOpen = documentPrototype.open;
			documentPrototype.open = function(){					
				var result = originalOpen.apply(this, arguments);
				if (!w.realSecretWindow){
					ads_app.setupBuiltInFunctions(w);
				}
				return result;					
			};

			var originalClose = documentPrototype.close;
			documentPrototype.close = function(){					
				var result = originalClose.apply(this, arguments);
				if (!w.realSecretWindow){
					ads_app.setupBuiltInFunctions(w);
				}
				return result;					
			};

			//this function is used for both document.write and document.writeln
			var rewriteDocWrite = function write(type){
				var originalWrite = documentPrototype[type];
				documentPrototype[type] = function(html){				
					"use strict";
				
					if (ads_app.disableDocWrite) {
						var ow = originalWrite.apply(w.document, arguments);
						if (!w.realSecretWindow){
							ads_app.setupBuiltInFunctions(w);
						}
						return ow;
					}

					if (ads_app.docWriteContext === ads_app.hostDomain)
						return originalWrite.apply(w.document, arguments);	
					
					//ads_app.checkDOMXSS(html, 'document.write');

					var result = ads_docWrite(html, ads_app.docWriteContext, {docwrite: true}, w, ads_app);

					var callResult = originalWrite.apply(this, [result]);
					

					//----------logging and ownership propagation-------//
					// Note: at this point, not all elements from 'result' is yet to be 
					// written by the browser because a <script> element can 
					// block the writing of elements after it. In fact, only elements up to
					// the first <script> element were written at this point.
					// 
					// The way docwrite works: in case of multiple docwrite calls,
					// for example: docwrite("aaaa<script src='x.js'></script>bbb"); docwrite("ccc"); 
					// then the final result will be aaa(whatever x.js docwrites)bbbccc
					//
					// Note that docwrite does not change the flow of code execution. For example:
					// docwrite("aaaa<script src='x.js'></script>bbb"); docwrite("ccc"); var t=1;
					// ==> "docwrite("ccc"); var t=1;" will be executed before any code in x.js
					//ads_app.processDocWriteNodes(w);
					//-----------------------------------------------------//



					if (!w.isAlreadyProcessed){
						ads_app.setupBuiltInFunctions(w);
					}
					return callResult;
				};

				if (w === top){ // store latest document.write in case it is rewritten
					ads_app["latestdoc" + type] = documentPrototype[type];
					ads_app["latestdoc" + type + "Setter"] = ads_app.hostName;
					var docwriteDesc = {};
					docwriteDesc.get = function(){return ads_app["latestdoc" + type];};
					docwriteDesc.set = function(newdocwrite){
						ads_app["latestdoc" + type] = ads_app.getWet(newdocwrite);
						ads_app.specialFunctionList.set(ads_app["latestdoc" + type], w);					
						ads_app["latestdoc" + type + "Setter"] = ads_app.currentContext;
						//dump("document.write is rewritten by " + ads_app.currentContext + "\n\n");
					};
					docwriteDesc.enumerable = true;
					docwriteDesc.configurable = true;
					originalObjectDefineProperty(w.document,type,docwriteDesc);
				}

			};

			rewriteDocWrite("write");
			rewriteDocWrite("writeln");


			originalSpecialFunctions.documentWrite = w.document.write;
			originalSpecialFunctions.documentWriteln = w.document.writeln;
			ads_app.specialFunctionList.set(w.document.write, w);
			ads_app.specialFunctionList.set(w.document.writeln, w);				
		}
	}
};