ads_app.dumpProxy =  function(m){	
	dump(m+"\n");
};


var dumpProxy = function(m){	
	dump(m+"\n");
};

ads_app.getDomain = ads_getDomain;

//if object is null, undefined or primive value
ads_app.isPrimitive = function(obj){
	return obj===null || obj===undefined || obj!==ads_app.originalObject(obj);
};



// for now, we just log operations related to DOM element creation
ads_app.addActToLog = function(order, act){
	//ads_app.logDomOperation(act);
	if (ads_app.addLog && ads_app.logRecords.length<40000){
		var stack;
		try{
			throw ads_app.originalError();
		}
		catch (e){
			stack = e.stack;
		}		
		
		if (!ads_app.noLogList.has(act.obj))
			ads_app.logRecords.push({order:order, act:act, stack:stack});
			if (act.op==='SET'){
			}
	}
};


// helper function for dumping logs
ads_app.printElm = function(elm, index, printStack){
	var act = elm.act; 
	var obj = act.obj;
	if (act.op === 'DOCUMENTWRITE'){			
		if (act.obj === obj){				
			console.log("Operation number " + index + ':\n FROM document.write' 
					+ "\nNode:" + ads_app.objectToString.call(act.obj) 
					+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
					(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
		}
	}
	if (act.op === 'INNERHTML'){			
		if (act.obj === obj){				
			console.log("Operation number " + index + ':\n FROM innerHTML of ' + ads_app.objectToString.call(act.initialNode) 
					+ "\nNode:" + ads_app.objectToString.call(act.obj) 
					+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
					(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
		}
	}
	if (act.op === 'CALL'){
		var matchArgs = false;
		for (var i=0;i<act.args.length;i++){
			if (obj === act.args[i]){
				matchArgs = true;
				break;
			}
		}
		if (act.obj === obj || act.thisValue === obj || act.result === obj || matchArgs){
			var argsString = "";
			for (var i=0;i<act.args.length;i++){
				if (ads_app.isPrimitive(act.args[i])){
					argsString = argsString + (i>0?", ":"") + act.args[i];
				}
				else{
					argsString = argsString + (i>0?", ":"") + ads_app.objectToString.call(act.args[i]);
				}
			}
			console.log("Operation number " + index + ':\n CALL ' + ads_app.functionToString.call(act.obj) + "\nthisValue:  " 
					+ ads_app.objectToString.call(act.thisValue) + "\nargs:" + argsString 
					+ "\nreturn value:" + (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result))
					+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee +   
					(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
		}
	}
	
	if (act.op === 'CONSTRUCT'){
		var matchArgs = false;
		for (var i=0;i<act.args.length;i++){
			if (obj === act.args[i]){
				matchArgs = true;
				break;
			}
		}
		if (act.obj === obj || act.thisValue === obj || act.result === obj || matchArgs){
			var argsString = "";
			for (var i=0;i<act.args.length;i++){
				if (ads_app.isPrimitive(act.args[i])){
					argsString = argsString + (i>0?", ":"") + act.args[i];
				}
				else{
					argsString = argsString + (i>0?", ":"") + ads_app.objectToString.call(act.args[i]);
				}
			}
			console.log("Operation number " + index + ':\n CONSTRUCT(new) ' + ads_app.functionToString.call(act.obj) + 
					"\nargs:" + argsString + "\nreturn value:" + (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result)) 
					+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
					(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
		}
	}
	
	if (act.op === 'SET'){	
		if (act.obj === obj || act.val === obj){				
			console.log("Operation number " + index + ':\n SET ' + ads_app.objectToString.call(act.obj) + 
					"\nproperty name:" + act.pn + "\nto value:" +  (ads_app.isPrimitive(act.val)?act.val:ads_app.objectToString.call(act.val)) 
					+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee +	(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
		}
	}
	
	if (act.op === 'GET'){			
		if (act.obj === obj || act.result === obj){				
			console.log("Operation number " + index + ':\n GET ' + ads_app.objectToString.call(act.obj) + 
					"\nproperty name:" + act.pn + "\nresult:" +  (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result)) 
					+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + (printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
		}
	}
};


// dump operation logs related to an object
ads_app.dumpLogObj = function(obj, printStack){
	if (ads_app.isPrimitive(obj)) return;
	obj = ads_app.getWet(obj);
	ads_app.logRecords.forEach(function(elm, index){
		var act = elm.act; 
		if (act.op === 'DOCUMENTWRITE'){			
			if (act.obj === obj){				
				console.log("Operation number " + index + ':\n FROM document.write' 
						+ "\nNode:" + ads_app.objectToString.call(act.obj) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
						(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		if (act.op === 'INNERHTML'){			
			if (act.obj === obj){				
				console.log("Operation number " + index + ':\n FROM innerHTML of ' + ads_app.objectToString.call(act.initialNode) 
						+ "\nNode:" + ads_app.objectToString.call(act.obj) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
						(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		if (act.op === 'CALL'){
			var matchArgs = false;
			for (var i=0;i<act.args.length;i++){
				if (obj === act.args[i]){
					matchArgs = true;
					break;
				}
			}
			if (act.obj === obj || act.thisValue === obj || act.result === obj || matchArgs){
				var argsString = "";
				for (var i=0;i<act.args.length;i++){
					if (ads_app.isPrimitive(act.args[i])){
						argsString = argsString + (i>0?", ":"") + act.args[i];
					}
					else{
						argsString = argsString + (i>0?", ":"") + ads_app.objectToString.call(act.args[i]);
					}
				}
				console.log("Operation number " + index + ':\n CALL ' + ads_app.functionToString.call(act.obj) + "\nthisValue:  " 
						+ ads_app.objectToString.call(act.thisValue) + "\nargs:" + argsString 
						+ "\nreturn value:" + (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result))
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee +   
						(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		
		if (act.op === 'CONSTRUCT'){
			var matchArgs = false;
			for (var i=0;i<act.args.length;i++){
				if (obj === act.args[i]){
					matchArgs = true;
					break;
				}
			}
			if (act.obj === obj || act.thisValue === obj || act.result === obj || matchArgs){
				var argsString = "";
				for (var i=0;i<act.args.length;i++){
					if (ads_app.isPrimitive(act.args[i])){
						argsString = argsString + (i>0?", ":"") + act.args[i];
					}
					else{
						argsString = argsString + (i>0?", ":"") + ads_app.objectToString.call(act.args[i]);
					}
				}
				console.log("Operation number " + index + ':\n CONSTRUCT(new) ' + ads_app.functionToString.call(act.obj) + 
						"\nargs:" + argsString + "\nreturn value:" + (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result)) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
						(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		
		if (act.op === 'SET'){	
			if (act.obj === obj || act.val === obj){				
				console.log("Operation number " + index + ':\n SET ' + ads_app.objectToString.call(act.obj) + 
						"\nproperty name:" + act.pn + "\nto value:" +  (ads_app.isPrimitive(act.val)?act.val:ads_app.objectToString.call(act.val)) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee +	(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		
		if (act.op === 'GET'){			
			if (act.obj === obj || act.result === obj){				
				console.log("Operation number " + index + ':\n GET ' + ads_app.objectToString.call(act.obj) + 
						"\nproperty name:" + act.pn + "\nresult:" +  (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result)) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + (printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
	});
};


//dump operation logs related to an object condition
ads_app.dumpLogCond = function(f, printStack){	
	ads_app.logRecords.forEach(function(elm, index){
		var obj = f.obj?f.obj:'tungtungtung';
		var act = elm.act;
		var cond = true;		
		if (act.op === 'DOCUMENTWRITE'){
			for (var e in f){
				if (f.hasOwnProperty(e))
					cond = cond && (f[e] === act[e]); 
			}
			if (cond){				
				console.log("Operation number " + index + ':\n FROM document.write' 
						+ "\nNode:" + ads_app.objectToString.call(act.obj) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
						(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		if (act.op === 'INNERHTML'){
			for (var e in f){
				if (f.hasOwnProperty(e))
					cond = cond && (f[e] === act[e]); 
			}
			if (cond){				
				console.log("Operation number " + index + ':\n FROM innerHTML of ' + ads_app.objectToString.call(act.initialNode) 
						+ "\nNode:" + ads_app.objectToString.call(act.obj) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
						(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		if (act.op === 'CALL'){
			var matchArgs = false;
			for (var i=0;i<act.args.length;i++){
				if (obj === act.args[i]){
					matchArgs = true;
					break;
				}
			}
			if (!f.obj || (act.obj === obj || act.thisValue === obj || act.result === obj || matchArgs)){
				var argsString = "";
				for (var i=0;i<act.args.length;i++){
					if (ads_app.isPrimitive(act.args[i])){
						argsString = argsString + (i>0?", ":"") + act.args[i];
					}
					else{
						argsString = argsString + (i>0?", ":"") + ads_app.objectToString.call(act.args[i]);
					}
				}
				for (var e in f){
					if (e!=='obj') cond = cond && (f[e] === act[e]); 
				}
				if (cond) 
					console.log("Operation number " + index + ':\n CALL ' + ads_app.functionToString.call(act.obj) + "\nthisValue:  " 
							+ ads_app.objectToString.call(act.thisValue) + "\nargs:" + argsString 
							+ "\nreturn value:" + (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result))
							+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee +   
							(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		
		if (act.op === 'CONSTRUCT'){
			var matchArgs = false;
			for (var i=0;i<act.args.length;i++){
				if (obj === act.args[i]){
					matchArgs = true;
					break;
				}
			}
			if (!f.obj || (act.obj === obj || act.thisValue === obj || act.result === obj || matchArgs)){
				var argsString = "";
				for (var i=0;i<act.args.length;i++){
					if (ads_app.isPrimitive(act.args[i])){
						argsString = argsString + (i>0?", ":"") + act.args[i];
					}
					else{
						argsString = argsString + (i>0?", ":"") + ads_app.objectToString.call(act.args[i]);
					}
				}
				for (var e in f){
					if (e!=='obj') cond = cond && (f[e] === act[e]); 
				}
				if (cond) 
					console.log("Operation number " + index + ':\n CONSTRUCT(new) ' + ads_app.functionToString.call(act.obj) + 
							"\nargs:" + argsString + "\nreturn value:" + (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result)) 
							+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + 
							(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}			
		}
		
		if (act.op === 'SET'){
			for (var e in f){
				if (e!=='obj' && f.hasOwnProperty(e))
					cond = cond && (f[e] === act[e]); 
			}
			if (cond && (!f.obj || (act.obj === obj || act.val === obj))){				
				console.log("Operation number " + index + ':\n SET ' + ads_app.objectToString.call(act.obj) + 
						"\nproperty name:" + act.pn + "\nto value:" +  (ads_app.isPrimitive(act.val)?act.val:ads_app.objectToString.call(act.val)) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee +	(printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
		
		if (act.op === 'GET'){
			for (var e in f){
				if (e!=='obj' && f.hasOwnProperty(e))
					cond = cond && (f[e] === act[e]); 
			}
			if (cond && (!f.obj || (act.obj === obj || act.result === obj))){				
				console.log("Operation number " + index + ':\n GET ' + ads_app.objectToString.call(act.obj) + 
						"\nproperty name:" + act.pn + "\nresult:" +  (ads_app.isPrimitive(act.result)?act.result:ads_app.objectToString.call(act.result)) 
						+ "\ncaller:  " +  act.caller + "\ncallee:  " +  act.callee + (printStack?("\nstack:  "+elm.stack +"\n"):"\n"));
			}
		}
	});
};


ads_app.printContextStack = function(){
	dump(ads_app.context.join(",") +"\n");
};


//add new script to the script generation tree
ads_app.addScriptToTree = function(script, callerContext, from){
	if (ads_app.processedScripts.has(script)){
		return;
	};
	ads_app.processedScripts.set(script,from);		
	if (!ads_app.scriptGenTree[callerContext]){
		ads_app.scriptGenTree[callerContext] = [];
	}
	ads_app.scriptGenTree[callerContext].push(script);
	if (script.src!==''){		
		ads_setDomainToConfine(script.src, callerContext);
	}
};

//dump the script generation tree
ads_app.dumpScriptGenTree = function(){
	dump("-----Script generation tree----\n")
	for (var domain in ads_app.scriptGenTree) {
		if (ads_app.scriptGenTree.hasOwnProperty(domain)) {
			dump(">>" + domain +"\n");
			ads_app.scriptGenTree[domain].forEach(function(e){
				var from = ads_app.processedScripts.get(e);
				if (e.src!==''){
					dump("   + " + ads_app.getDomain(e.src) + " (" + from + ")" + "\n");
				}
				else{
					var content = (e.textContent?e.textContent:e.text);
					dump("   + Inline: " + content.substring(0,40) + "... (" + from + ")" + "\n");
				}
			});				
		}
	}
};


//this function merge two arrays removing duplicated elements
ads_app.mergeArrays = function(array1, array2){
	for(var i = 0; i < array2.length; i++){
        if(array1.indexOf(array2[i]) === -1) {
        	array1.push(array2[i]);
        }
    }
	return array1;
};


//----------logging and ownership propagation for nodes from docwrite-------//
ads_app.processDocWriteNodes = function processDocWriteNodes(w){
	var newNodes = w.document.querySelectorAll("[data-ads-app-owner]");	
	for (var i=0;i<newNodes.length;i++){		
		var aNode = newNodes[i];	
		ads_app.addActToLog(ads_app.opOrder++, {op:"DOCUMENTWRITE", obj:aNode, caller:ads_app.hostDomain, callee:ads_app.hostDomain});
		if (aNode.tagName === "SCRIPT"){
			ads_app.addScriptToTree(aNode, ads_app.hostDomain, "docwrite");
		}
	}
};



// this function does context switch which also 
// handles prototype extension
// context1: current context
// context2: next context
ads_app.switchContext = function(context1, context2){
	ads_app.context.push(context1);
	ads_app.currentContext = context2;
	for (var i=0;i<ads_app.modifiedNativePrototypes.length;i++){
		var np = ads_app.modifiedNativePrototypes[i];
		var allAddedProperties = ads_app.allAddedPropertiesToNativeProto.get(np);
		var context1AddedProperties = allAddedProperties[context1];
		var context2AddedProperties = allAddedProperties[context2];
		
		// if shadow is enabled, then remove all but properties added 
		// by context2 from np
		if (ads_app.shadowEnabled){			
			// remove properties added by context1 from native prototypes
			for (var j in context1AddedProperties){
				if (context1AddedProperties.hasOwnProperty(j)){
					delete np[j];
					//np[j] = ads_app.orginialFunction();
				}
			}
			
			// add properties from context2 to native prototypes
			for (var j in context2AddedProperties){
				if (context2AddedProperties.hasOwnProperty(j)){
					np[j] = context2AddedProperties[j];
				}
			}			
		}
		else{
			// convert properties added by context1 to native prototypes
			// to dry
			for (var j in context1AddedProperties){
				if (context1AddedProperties.hasOwnProperty(j)){
					delete np[j];
					
				}
			}
			
			// convert properties added by context2 to native prototypes
			// to wet
			for (var j in context2AddedProperties){
				if (context2AddedProperties.hasOwnProperty(j)){
					np[j] = context2AddedProperties[j];
				}
			}
		}
		
		
	}
};
